#This should parse an XML file and retrieve the data stored within its elements
import sys, os
from xml.dom import minidom

try:
    import Blender
except ImportError:
    pass

def getPRPXML():
    basefilename = 'pyprp.xml'
    fullpath = os.path.join(Blender.Get('scriptsdir'), basefilename)
    if os.path.isfile(fullpath):
        return fullpath
    fullpath2 = os.path.join(Blender.Get('uscriptsdir'),basefilename)
    print "Could not find %s, checking for %s..." %(fullpath,fullpath2)
    if os.path.isfile(fullpath2):
        return fullpath2
    fullpath3 = os.path.join(os.path.expanduser("~"),basefilename)
    print "Coud not find %s or %s, checking for %s..." %(fullpath,fullpath2,fullpath3)
    if os.path.isfile(fullpath3):
        return fullpath3
    raise "Could not locate %s, %s or %s" %(fullpath,fullpath2,fullpath3)

#
"""This file reads the XML configurations from the pyprp.xml file using the minidom XML parser. These settings are retrieved by alcconfig.py"""
#
xmldoc = minidom.parse(getPRPXML())

#Enter only the <alcugs> section
alcNode = xmldoc.getElementsByTagName('alcugs')

#Read the Path variables
pathNode = alcNode[0].getElementsByTagName('path')
PATH = pathNode[0].firstChild.data

#Read the Vertex Compression variable (true or false)
vertexNode = alcNode[0].getElementsByTagName('vertex_compression')
VERTEX_COMPRESSION = vertexNode[0].firstChild.data

#Read the Texture Compression variable (true or false)
texCNode = alcNode[0].getElementsByTagName('texture_compression')
TEXTURE_COMPRESSION = texCNode[0].firstChild.data

#Read the Texture Mipmap variable (true or false)
mipNode = alcNode[0].getElementsByTagName('texture_mipmaps')
TEXTURE_MIPMAPS = mipNode[0].firstChild.data

#Read the Texture Resize variable (true or false)
texRNode = alcNode[0].getElementsByTagName('texture_resize')
TEXTURE_RESIZE = texRNode[0].firstChild.data

#Read the Texture Cache variable (true or false)
cacheNode = alcNode[0].getElementsByTagName('texture_cache')
TEXTURE_CACHE = cacheNode[0].firstChild.data

#Read the Game Version variable
gameNode = alcNode[0].getElementsByTagName('game_version')
GAME_VERSION = gameNode[0].firstChild.data

#Read the Debug Level variable
dbgNode = alcNode[0].getElementsByTagName('debug_level')
DEBUG_LEVEL = dbgNode[0].firstChild.data

#Read the Refresh variable
refrNode = alcNode[0].getElementsByTagName('refresh')
REFRESH = refrNode[0].firstChild.data

#Read the Export Textures variable
eTexNode = alcNode[0].getElementsByTagName('export_pages')
EXPORT_TEXTURES = eTexNode[0].firstChild.data

#Read the import variable
imptNode = alcNode[0].getElementsByTagName('import')
IMPORT = imptNode[0].firstChild.data