#
# $Id: alc_Classes.py 862 2007-11-05 23:07:02Z trylon $
#
#    Copyright (C) 2005-2006  Alcugs pyprp Project Team
#    See the file AUTHORS for more info about the team
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Please see the file COPYING for the full license.
#    Please see the file DISCLAIMER for more details, before doing nothing.
#

try:
    import Blender
    try:
        from Blender import Mesh
        from Blender import Lamp
    except Exception, detail:
        print detail
except ImportError:
    pass

import md5, random, binascii, cStringIO, copy, Image, math, struct, StringIO, os, os.path, pickle
from enum import Enum
from alcurutypes import *
from alcdxtconv import *
from alchexdump import *
from alcurugeom import *
from alcGObjects import *
from alcConvexHull import *
from alcrespmod import * 
from alc_AbsClasses import *
from alc_Creatable import *
from alc_VolumeIsect import *
from alc_MatClasses import *
from alc_CamClasses import *
from alc_AlcScript import *

import alcconfig, alchexdump
def stripIllegalChars(name):
    name=name.replace("*","_")
    name=name.replace("?","_")
    name=name.replace("\\","_")
    name=name.replace("/","_")
    name=name.replace("<","_")
    name=name.replace(">","_")
    name=name.replace(":","_")
    name=name.replace("\"","_")
    name=name.replace("|","_")
    name=name.replace("#","_")
    name=name.strip()
    return name
    
def Create(version=5):
    if version==6: #Myst 5 Object Types - Add to me!
        Types = Enum('plSceneNode',                                 #Type 0x00
                     'plSceneObject',                               #Type 0x01
                     'hsKeyedObject',                               #Type 0x02
                     'plBitmap',                                    #Type 0x03
                     'plMipMap',                                    #Type 0x04
                     'plCubicEnvironMap',                           #Type 0x05
                     'plLayer',                                     #Type 0x06
                     'hsGMaterial',                                 #Type 0x07
                     'plParticleSystem',                            #Type 0x08
                     'plParticleEffect',                            #Type 0x09
                     'plParticleCollisionEffectBeat',               #Type 0x0A
                     'plParticleFadeVolumeEffect',                  #Type 0x0B
                     'plBoundInterface',                            #Type 0x0C
                     'plRenderTarget',                              #Type 0x0D
                     'plCubicRenderTarget',                         #Type 0x0E
                     'plCubicRenderTargetModifier',                 #Type 0x0F
                     'plObjInterface',                              #Type 0x10
                     'plAudioInterface',                            #Type 0x11
                     'plAudible',                                   #Type 0x12
                     'plAudibleNull',                               #Type 0x13
                     'plWinAudible',                                #Type 0x14
                     'plCoordinateInterface',                       #Type 0x15
                     'plDrawInterface',                             #Type 0x16
                     'plDrawable',                                  #Type 0x17
                     'plAutoWalkRegion',                            #Type 0x18
                     'plDrawableIce',                               #Type 0x19
                     'plPhysical',                                  #Type 0x1A
                     'plCrossfade',                                 #Type 0x1B
                     'plSimulationInterface',                       #Type 0x1C
                     'plParticleFadeOutEffect',                     #Type 0x1D
                     'plModifier',                                  #Type 0x1E
                     'plSingleModifier',                            #Type 0x1F
                     'plSimpleModifier',                            #Type 0x20
                     'plWindBoneMod',                               #Type 0x21
                     'plCameraBrain_NovicePlus',                    #Type 0x22
                     'plGrassShaderMod',                            #Type 0x23
                     'plDetectorModifier',                          #Type 0x24
                     'pfSubtitleMgr',                               #Type 0x25
                     'plPythonFileModConditionalObject',            #Type 0x26
                     'plMultiModifier',                             #Type 0x27
                     'plSynchedObject',                             #Type 0x28
                     'plSoundBuffer',                               #Type 0x29
                     'plPickingDetector',                           #Type 0x2A
                     'plCollisionDetector',                         #Type 0x2B
                     'plLogicModifier',                             #Type 0x2C
                     'plConditionalObject')                         #Type 0x2D
        #fin de list
    else: #Uru Object Types
        Types = Enum('plSceneNode',                                 #Type 0x00
                     'plSceneObject',                               #Type 0x01
                     'hsKeyedObject',                               #Type 0x02
                     'plBitmap',                                    #Type 0x03
                     'plMipMap',                                    #Type 0x04
                     'plCubicEnvironMap',                           #Type 0x05
                     'plLayer',                                     #Type 0x06
                     'hsGMaterial',                                 #Type 0x07
                     'plParticleSystem',                            #Type 0x08
                     'plParticleEffect',                            #Type 0x09
                     'plParticleCollisionEffectBeat',               #Type 0x0A
                     'plParticleFadeVolumeEffect',                  #Type 0x0B
                     'plBoundInterface',                            #Type 0x0C
                     'plRenderTarget',                              #Type 0x0D
                     'plCubicRenderTarget',                         #Type 0x0E
                     'plCubicRenderTargetModifier',                 #Type 0x0F
                     'plObjInterface',                              #Type 0x10
                     'plAudioInterface',                            #Type 0x11
                     'plAudible',                                   #Type 0x12
                     'plAudibleNull',                               #Type 0x13
                     'plWinAudible',                                #Type 0x14
                     'plCoordinateInterface',                       #Type 0x15
                     'plDrawInterface',                             #Type 0x16
                     'plDrawable',                                  #Type 0x17
                     'plDrawableMesh',                              #Type 0x18
                     'plDrawableIce',                               #Type 0x19
                     'plPhysical',                                  #Type 0x1A
                     'plPhysicalMesh',                              #Type 0x1B
                     'plSimulationInterface',                       #Type 0x1C
                     'plCameraModifier',                            #Type 0x1D
                     'plModifier',                                  #Type 0x1E
                     'plSingleModifier',                            #Type 0x1F
                     'plSimpleModifier',                            #Type 0x20
                     'plSimpleTMModifier',                          #Type 0x21
                     'plRandomTMModifier',                          #Type 0x22
                     'plInterestingModifier',                       #Type 0x23
                     'plDetectorModifier',                          #Type 0x24
                     'plSimplePhysicalMesh',                        #Type 0x25
                     'plCompoundPhysicalMesh',                      #Type 0x26
                     'plMultiModifier',                             #Type 0x27
                     'plSynchedObject',                             #Type 0x28
                     'plSoundBuffer',                               #Type 0x29
                     'plAliasModifier',                             #Type 0x2A
                     'plPickingDetector',                           #Type 0x2B
                     'plCollisionDetector',                         #Type 0x2C
                     'plLogicModifier',                             #Type 0x2D
                     'plConditionalObject',                         #Type 0x2E
                     'plANDConditionalObject',                      #Type 0x2F
                     'plORConditionalObject',                       #Type 0x30
                     'plPickedConditionalObject',                   #Type 0x31
                     'plActivatorConditionalObject',                #Type 0x32
                     'plTimerCallbackManager',                      #Type 0x33
                     'plKeyPressConditionalObject',                 #Type 0x34
                     'plAnimationEventConditionalObject',           #Type 0x35
                     'plControlEventConditionalObject',             #Type 0x36
                     'plObjectInBoxConditionalObject',              #Type 0x37
                     'plLocalPlayerInBoxConditionalObject',         #Type 0x38
                     'plObjectIntersectPlaneConditionalObject',     #Type 0x39
                     'plLocalPlayerIntersectPlaneConditionalObject',#Type 0x3A
                     'plPortalDrawable',                            #Type 0x3B
                     'plPortalPhysical',                            #Type 0x3C
                     'plSpawnModifier',                             #Type 0x3D
                     'plFacingConditionalObject',                   #Type 0x3E
                     'plHKPhysical')                                #Type 0x3F
        #fin de list

class plSceneNode(hsKeyedObject):                           #Type 0x00
    def __init__(self,parent,name="unnamed"):               #Members
        hsKeyedObject.__init__(self,parent,name,0x0000)            #Base
        self.SceneObjects=hsTArray([0x01],self.getVersion())                  #plSceneObjects (vector)
        if self.getVersion()==6:
            ##myst5 types
            self.OtherObjects=hsTArray([0xCD,0x6B,0x80,0x8E,0x0110],6)
        else:
            ##Uru types
            self.OtherObjects=hsTArray([0x7A,0x98,0xA8,0xB5,0xE4,0xE8,0xE9,0xEA,0xED,0xF1,0x0109,0x010A,0x0129,0x012A,0x012B],5)


    def changePageRaw(self,sid,did,stype,dtype):
        self.SceneObjects.changePageRaw(sid,did,stype,dtype)
        self.OtherObjects.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)
        self.SceneObjects.ReadVector(stream)
        self.OtherObjects.ReadVector(stream)
       # size, = struct.unpack("I",stream.read(4))
       # for i in range(size):
       #     o = UruObjectRef(self.getVersion())
       #     o.read(stream)
       #     #print o
       #     if not o.Key.object_type in self.data1allow:
       #         raise RuntimeError, "Type %04X is not a plSceneObject [0x0000]" % o.Key.object_type
       #     self.data1.append(o)
       # size, = struct.unpack("I",stream.read(4))
       # for i in range(size):
       #     o = UruObjectRef(self.getVersion())
       #     o.read(stream)
       #     if not o.Key.object_type in self.data2allow:
       #         raise RuntimeError, "Type %04X is not in allow list 2" % o.Key.object_type
       #     self.data2.append(o)
       # assert(self.verify())


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        self.SceneObjects.WriteVector(stream)
        self.OtherObjects.WriteVector(stream)
       # stream.write(struct.pack("I",len(self.data1)))
       # for o in self.data1:
       #     #o.update(self.Key)
       #     o.write(stream)
       # stream.write(struct.pack("I",len(self.data2)))
       # for o in self.data2:
       #     #o.update(self.Key)
       #     o.write(stream)


    def dump(self):
        print "BEGIN SceneNode: " + self.Key.name
        hsKeyedObject.dump(self)
        print "SceneObjects - %i" % self.SceneObjects.size
        i=0
        for o in self.SceneObjects:
           print "[%i] %s" %(i,o)
           i=i+1
        print "Other Objects - %i" % self.OtherObjects.size
        i=0
        for o in self.OtherObjects:
           print "[%i] %s" %(i,o)
           i=i+1
        print "# END [%04X] %s" % (self.Key.object_type, self.Key.name)


    def import_all(self):
        root = self.getRoot()
        for ref in self.SceneObjects.vector:
            o=root.findref(ref)
            #print str(ref), o
            print "importing %s" %o.data.Key.name
            #if str(o.data.Key.name)!="Door_Right":
                #continue
            o.dump()
            o.data.import_all()
        Blender.Redraw()


class plSceneObject(plSynchedObject):                       #Type 0x01
    def __init__(self,parent,name="unnamed"):               #Members
        plSynchedObject.__init__(self,parent,name,0x01)
        self.draw=UruObjectRef()                            #Span Info
        self.simulation=UruObjectRef()                      #Animation Info
        self.coordinate=UruObjectRef()                      #Region Info
        self.audio=UruObjectRef()                           #Sound Info
        self.scene=UruObjectRef()                           #SceneNode to which this object belong
        if self.getVersion()==6:
            #myst5 types
            self.data1=hsTArray([0x0C,0x50,0x51,0x52,0x5A,0x5B,0x76,0xB5,0xB6],6)
            self.data2=hsTArray([0x08,0x1B,0x21,0x23,0x2A,0x2C,0x3B,0x3C,0x3E,0x56,0x57,0x5F,0x60,0x62,0x6A,0x6C,0x6D,0x6E,0x7D,0x83,0x87,0x88,0x8A,0x91,0x92,0x94,0x97,0x98,0x9C,0x9E,0xA5,0xAC,0xB4,0xC1,0xD0,0xD4,0xD8,0xE0,0xF1,0x0106,0x010E,0x0113,0x0114],6)
        else:
            #uru types
            self.data1=hsTArray([0x0C,0x55,0x56,0x57,0x67,0x6A,0x88,0xD5,0xD6,0xE2,0xEC,0xF6,0x0116,0x011E,0x0133,0x0134,0x0136],5)
            self.data2=hsTArray([0x08,0x2A,0x2B,0x2D,0x3D,0x40,0x62,0x6C,0x6D,0x6F,0x71,0x76,0x77,0x79,0x7A,0x7B,0x7C,0x8F,0x95,0x9B,0xA1,0xA2,0xA4,0xA9,0xAA,0xAB,0xAC,0xAE,0xAF,0xB1,0xB2,0xB9,0xBA,0xBB,0xBD,0xC0,0xC1,0xC4,0xCB,0xCF,0xD4,0xE5,0xE7,0xEE,0xF3,0xF5,0xFB,0xFC,0xFF,0x0107,0x0108,0x010C,0x010D,0x0119,0x0122,0x012C,0x012E,0x012F,0x0131],5)

    def changePageRaw(self,sid,did,stype,dtype):
        plSynchedObject.changePageRaw(self,sid,did,stype,dtype)
        self.draw.changePageRaw(sid,did,stype,dtype)
        self.simulation.changePageRaw(sid,did,stype,dtype)
        self.coordinate.changePageRaw(sid,did,stype,dtype)
        self.audio.changePageRaw(sid,did,stype,dtype)
        for i in self.data1.vector:
            i.changePageRaw(sid,did,stype,dtype)
        for i in self.data2.vector:
            i.changePageRaw(sid,did,stype,dtype)
        self.scene.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        plSynchedObject.read(self,stream)
        self.draw.setVersion(self.getVersion())
        self.simulation.setVersion(self.getVersion())
        self.coordinate.setVersion(self.getVersion())
        self.audio.setVersion(self.getVersion())
        self.scene.setVersion(self.getVersion())
        self.draw.read(stream)
        self.simulation.read(stream)
        self.coordinate.read(stream)
        self.audio.read(stream)
        self.data1.ReadVector(stream)
        self.data2.ReadVector(stream)
        self.scene.read(stream)


    def write(self,stream):
        plSynchedObject.write(self,stream)
        self.draw.write(stream)
        self.simulation.write(stream)
        self.coordinate.write(stream)
        self.audio.write(stream)
        self.data1.WriteVector(stream)
        self.data2.WriteVector(stream)
        self.scene.write(stream)


    def dump(self):
        print "BEGIN SceneObject %s" % (self.Key.name)
        plSynchedObject.dump(self)
        print "Draw: %s" % self.draw
        print "Simulation: %s" % self.simulation
        print "Coordinate: %s" % self.coordinate
        print "Audio: %s" % self.audio
        print "Object Refs - %i" % len(self.data1)
        i=0
        for o in self.data1.vector:
           print "[%i] %s" %(i,o)
           i=i+1
        print "Modifier Refs - %i" % len(self.data2)
        i=0
        for o in self.data2.vector:
           print "[%i] %s" %(i,o)
           i=i+1
        print "Scene: %s" % self.scene
        print "# END [%04X] %s" % (self.Key.object_type, self.Key.name)


##    def verify(self):
##        if not self.draw.verify(self.Key):
##            return 0
##        if not self.simulation.verify(self.Key):
##            return 0
##        if not self.coordinate.verify(self.Key):
##            return 0
##        if not self.audio.verify(self.Key):
##            return 0
##        #for o in self.data1:
##            #if not o.verify(self.Key):
##                #return 0
##        #for o in self.data2:
##            #if not o.verify(self.Key):
##                #return 0
##        if not self.scene.verify(self.Key):
##            return 0
##        return 1


    def import_all(self):
        assert(self.draw.checktype(0x0016)) #or self.draw.checktype(0x00D2))
        root = self.getRoot()
        #draw
        draw = root.findref(self.draw)
        if draw!=None:
            draw.dump()
            draw.data.import_all(str(self.Key.name))
        #coordinate
        coordinate = root.findref(self.coordinate)
        matrix2 = hsMatrix44()
        if coordinate!=None and self.getVersion() != 6 and coordinate.data.Key.object_type == 0x0015: # since this ref also accepts 0xFE (FilterCoordinate Types)
            coordinate.dump()
            matrix2=coordinate.data.matrix2
            if draw!=None:
                draw.data.transform(coordinate.data.matrix2)
        #simulation
        phys=None
        simulation = root.findref(self.simulation)
        if simulation!=None and self.getVersion() != 6:
            simulation.dump()
            blenderObjects = None
            if draw != None:
                blenderObjects = draw.data.blenderobjects
            simulation.data.import_all(str(self.Key.name),matrix2,blenderObjects)
            phys=root.findref(simulation.data.physical)
            #if draw!=None and phys!=None:
            #    for objs in draw.data.blenderobjects:
            #        for obj in objs:
            #            obj.addProperty("mass",float(phys.data.mass))
        # Stick in non-zero mass property
        if simulation == None and coordinate != None and draw != None:
            for objs in draw.data.blenderobjects:
                for obj in objs:
                    obj.addProperty("mass",1.0)
            
        pointHandled = 0
        #light
        lightobjs = []
        for li in  self.data1.vector:
            if li.Key.object_type in [0x55,0x56,0x57]:
                light=root.findref(li)
                lightobjs.append(light.data.import_all(str(self.Key.name),matrix2))
                pointHandled = 1

    
        #shadow
        for sh in  self.data1.vector:
            if sh.Key.object_type in [0xD5,0xD6]:
                shadow=root.findref(sh)
                for obj in lightobjs:
                    shadow.data.import_obj(obj)
                pointHandled = 1

        #ViewFaceModifier
        for vfm in self.data2.vector:
            if vfm.Key.object_type in [0x40]:
                viewface=root.findref(vfm)
                viewface.dump()
                #There should be some sort of test here to determine if the VFM is not null
                if (viewface != None and draw): #ViewFaceModifier
                    prptype = "viewfacemodifier"
               #     vmod = alcCreateViewFaceMod("ViewFaceModifier")
                    
                    for objs in draw.data.blenderobjects:
                        for obj in objs:
                            try:
                                p=obj.getProperty("alctype")
                                obj.removeProperty(p)
                            except (AttributeError, RuntimeError):
                                pass
                            obj.addProperty("alctype","sprite")
                            viewface.data.import_obj(obj)    
               #     print "ViewFaceModifier %s" % str(self.Key.name)
               #     pass

        
        #modifiers 1
        rgn_swimsfc = None
        for mod in self.data1.vector:
            if (mod.Key.object_type==0x0133) or (mod.Key.object_type==0x0134) or (mod.Key.object_type==0x0136): #SpawnModifier
                print "Detected Swim Surface Modifier"
                rgn_swimsfc = mod # save this modifier
            elif mod.Key.object_type==0x0088 and self.getVersion() != 6: #SoftVolumeSimple
                softVolume = root.findref(mod)
                if softVolume != None:
                    softVolume.data.import_all()
                pass


        #modifiers 2
        rgn_objinvolmod = None
        rgn_camregion = None
        rgn_climbregion = None
        rgn_paniclinkregion = None
        rgn_swimregion = None
        rgn_objinvolmod = None
        rgn_haslogicmod = 0
        rgn_logicmods = []
        rgn_respmod = None
        rgn_ifinfomod = None
        cam_cameramod = None
        
        
        for mod in self.data2.vector:
            if mod.Key.object_type==0x3D: #SpawnModifier
                #create a linkInPoint
                pointHandled = 1
                obj=alcCreateLinkInPoint(str(self.Key.name),matrix2,self.getPageNum())
            #Noooooo!!!! There is a better way!
            #elif mod.Key.object_type==0xA2: #PythonFileMod
            #    PyMod = root.findref(mod)
            #    obj = phys.data.blendobj
            #    obj.addProperty("PyMod",PyMod.PyFile)
            #    for i in range(len(PyMod.PyArgs)):
            #        Arg = PyMod.PyArgs[i]
            #        Bad = (6, 7, 8, 9, 10, 11, 12, 14, 15, 18, 19, 20, 21)
            #        if Arg.type in Bad:
            #            print "Skipping PyArg, it is a plKeyRef :("
            #            continue
            #        obj.addProperty("PyArg" + Arg.idx,Arg.data)
            elif mod.Key.object_type==0xA2 and draw != None and phys != None:
                PyMod = root.findref(mod)
                if PyMod != None:
                    blenderObjects = draw.data.blenderobjects
                    for objList in blenderObjects:
                        for obj in objList:
                            obj.addProperty("clickfile",str(PyMod.data.PyFile))
            elif mod.Key.object_type==0x00B2 and self.getVersion() != 6: #AvLadderMod
                                
                rgn_climbregion = root.findref(mod)

#                climbRegion = root.findref(mod)
#                if climbRegion != None and phys:
#                    obj = phys.data.blendobj
#                    obj.addProperty("alcspecial","climbregion")
#                    climbRegion.data.import_obj(obj)
            elif mod.Key.object_type==0x002D and self.getVersion() != 6: #LogicModifier
                #Contains Volumesensor Object....
                rgn_haslogicmod += 1
                rgn_logicmods.append(root.findref(mod))
                pass
            elif mod.Key.object_type==0x007B and self.getVersion() != 6: #ObjectInvolumeDetector
                rgn_objinvolmod = root.findref(mod)
                # has option c70 (either 0 or 4)
                pass
            elif mod.Key.object_type==0x00CB and self.getVersion() != 6: #InterfaceInfoModifier
                rgn_ifinfomod = root.findref(mod)
                pass
            elif mod.Key.object_type==0x007C and self.getVersion() != 6: #ResponderModifier
                rgn_respmod = root.findref(mod)
                pass
            elif mod.Key.object_type==0x012E and self.getVersion() != 6: #SwimRegion
                rgn_swimregion = root.findref(mod)
                pass                
            elif mod.Key.object_type==0x006F and self.getVersion() != 6: #CameraRegionDetector
                rgn_camregion = root.findref(mod)
                #cameraregionDetector is not yet implemented!
                #please add processing as implementation follows
                pass
            elif mod.Key.object_type==0x00FC and self.getVersion() != 6: #PaniclinkRegion
                rgn_paniclinkregion = root.findref(mod)
                pass
            elif mod.Key.object_type==0x009B and self.getVersion() != 6: #CameraModifier
                cam_cameramod = root.findref(mod)
                pass                
        #see if we have a region (exclude bounding sphere regins, since they aren't supported correctly)
        if(phys and phys.data.format != 2 and (phys.data.blendobj != None) and
            ( (rgn_objinvolmod != None) or 
              (rgn_camregion != None) or 
              (rgn_climbregion != None) or 
              (rgn_paniclinkregion != None) or 
              (rgn_swimregion != None) or 
              (rgn_swimsfc != None) or 
              ((rgn_objinvolmod != None) and (rgn_haslogicmod != 0) and (rgn_respmod != None) and (rgn_ifinfomod != None))
              ) ):
            
            print "Found Region with name %s" % str(self.Key.name)
            
            isregion = 1
            obj = phys.data.blendobj
            
            try:
                p=obj.getProperty("alctype")
                obj.removeProperty(p)
            except (AttributeError, RuntimeError):
                pass
            obj.addProperty("alctype","region")
            obj.layers = [4,]
            obj.setDrawMode(2)
            
            # remove object Properties if they are default
            
            # find out what kind of region it is.
            prpregion = "unknown"
            if ((rgn_objinvolmod != None) and 
                  (rgn_haslogicmod == 2) and 
                  (rgn_respmod != None) and 
                  (rgn_ifinfomod != None)):  # Footstep region
                prpregion = "footsteprgn"
                obj.addProperty("prpregion",prpregion)
                # Uncomment these once plResponderModifier (and all
                #  the message types) have their read() methods implemented
                #ftgroup = rgn_respmod.data.respmodGroup[0]
                #ftaction1 = ftgroup.actions[0]
                #soundID = ftaction1.message.data.groundtype
                soundID = 11
                obj.addProperty("footstepsound",soundID,'INT')
                print "Region %s is a Footstep Sound Region" % str(self.Key.name)
                
                for mylogicmod in rgn_logicmods:
                    # walk through the conditionals and import if it's a VolumeSensor
                    for cond in mylogicmod.data.Conditionals:
                        if cond.Key.object_type == 0x00A6:
                            volsens = root.findref(cond)
                            volsens.data.import_obj(obj)
                
                
                pass
            elif (rgn_camregion != None):  # Camera region
                prpregion = "camerargn"
                obj.addProperty("prpregion",prpregion)
                print "Region %s is a Camera Region" % str(self.Key.name)
                obj.layers = [5,]
                rgn_camregion.data.import_obj(obj)
                pass
            elif (rgn_swimregion != None): #swim Region

                prpregion = "swimrgn"
                obj.addProperty("prpregion",prpregion)
                print "Region %s is a Swim Detector Region" % str(self.Key.name)
                pass
            elif (rgn_swimsfc != None): #swim Region
                print "Region %s is a Swim Surface Region" % str(self.Key.name)
                # set the correct prpregion type
                if rgn_swimsfc.Key.object_type==0x0133:
                    prpregion = "swimplainsfc"
                elif rgn_swimsfc.Key.object_type==0x0134:
                    prpregion = "swimccursfc"
                elif rgn_swimsfc.Key.object_type==0x0136:
                    prpregion = "swimscursfc"

                obj.addProperty("prpregion",prpregion)
                swimsfc = root.findref(rgn_swimsfc)
                swimsfc.data.import_obj(obj)
                pass
            elif (rgn_climbregion != None): # climbing region
                prpregion = "climbregion"
                obj.addProperty("prpregion",prpregion)
                rgn_climbregion.data.import_obj(obj)
                print "Region %s is a Climbing Region" % str(self.Key.name)
                pass
            elif (rgn_paniclinkregion != None): # panic link region
                prpregion = "paniclnkrgn"
                obj.addProperty("prpregion",prpregion)
                print "Region %s is a Panic Link Region" % str(self.Key.name)
                pass
            elif ((rgn_objinvolmod != None) and 
                  (rgn_haslogicmod == 0) and 
                  (rgn_respmod == None) and 
                  (rgn_ifinfomod == None)): # click region 
                prpregion = "clickregion"
                obj.addProperty("prpregion",prpregion)
                print "Region %s is a Click Region" % str(self.Key.name)
                pass
            else:
                print "Region %s is an Unknown Region" % str(self.Key.name)
                obj.layers = [5,]
                pass


            #remove default properties (depending on the type of region)
            if(prpregion == "swimregion"):
                self.deldefaultproperty(obj,"mass",0.0);
                self.deldefaultproperty(obj,"rc",0.0);
                self.deldefaultproperty(obj,"el",0.0);
                self.deldefaultproperty(obj,"col_type","1");
                self.deldefaultproperty(obj,"col_flags0","0000");
                self.deldefaultproperty(obj,"col_flags1","00020000");
                self.deldefaultproperty(obj,"col_flags2","00000000");
                self.deldefaultproperty(obj,"col_flags3","0000");
                self.deldefaultproperty(obj,"col_flags4","00000000");
                self.deldefaultproperty(obj,"col_flags5","00000000");
            elif (prpregion == "swimplainsfc") or (prpregion == "swimccursfc") or (prpregion == "swimscursfc"):
                self.deldefaultproperty(obj,"mass",0.0);
                self.deldefaultproperty(obj,"rc",0.0);
                self.deldefaultproperty(obj,"el",0.0);
                self.deldefaultproperty(obj,"col_type","4");
                self.deldefaultproperty(obj,"col_flags0","0000");
                self.deldefaultproperty(obj,"col_flags1","00000000");
                self.deldefaultproperty(obj,"col_flags2","00000000");
                self.deldefaultproperty(obj,"col_flags3","0000");
                self.deldefaultproperty(obj,"col_flags4","00000000");
                self.deldefaultproperty(obj,"col_flags5","00000080");
            elif (prpregion == "clickregion"):
                self.deldefaultproperty(obj,"mass",1.0);
                self.deldefaultproperty(obj,"rc",0.0);
                self.deldefaultproperty(obj,"el",0.0);
                self.deldefaultproperty(obj,"col_type","3");
                self.deldefaultproperty(obj,"col_flags0","0400");
                self.deldefaultproperty(obj,"col_flags1","08000000");
                self.deldefaultproperty(obj,"col_flags2","00000000");
                self.deldefaultproperty(obj,"col_flags3","0000");
                self.deldefaultproperty(obj,"col_flags4","00000004");
                self.deldefaultproperty(obj,"col_flags5","00000000");
            elif (prpregion != "unknown"):
                self.deldefaultproperty(obj,"mass",1.0);
                self.deldefaultproperty(obj,"rc",0.0);
                self.deldefaultproperty(obj,"el",0.0);
                self.deldefaultproperty(obj,"col_type","3");
                self.deldefaultproperty(obj,"col_flags0","0400");
                self.deldefaultproperty(obj,"col_flags1","08000000");
                self.deldefaultproperty(obj,"col_flags2","00000000");
                self.deldefaultproperty(obj,"col_flags3","0000");
                self.deldefaultproperty(obj,"col_flags4","00000004");
                self.deldefaultproperty(obj,"col_flags5","00000000");


                
            
        ###############################
        # Trylon added support for "point" objects - empty meshes with only a coordinate interface
        ###############################
        if simulation == None and coordinate != None and draw == None and pointHandled == 0 :
            name = str(self.Key.name)
            #the_name=alcUniqueName(name)
            the_name = name
            if(cam_cameramod == None):
                # make the point object
                boxsize = 0.5
                obj = alcCreateBox(the_name,boxsize,-(boxsize/2),-(boxsize/2),-(boxsize/2))
                obj.layers=[2,]
                obj.addProperty("alctype","point")

                # apply the matrix
                m=matrix2.get()
                m.transpose()
                obj.setMatrix(m)

                # set the properties
                # to make it extra visible, we delibirately don't set it to wireframe mode
                obj.addProperty("page_num",str(self.getPageNum()))

            else: # we have a camera
                cam = Blender.Camera.New("persp",the_name)
                obj = Blender.Object.New("Camera")
                obj.link(cam)
                scn = Blender.Scene.GetCurrent()
                scn.link(obj)
                obj.layers=[5,]
                obj.addProperty("alctype","camera")
                obj.setName(the_name)
                # apply the matrix
                m=matrix2.get()
                m.transpose()
                obj.setMatrix(m)

                # set the properties 
                # to make it extra visible, we delibirately don't set it to wireframe mode
                obj.addProperty("page_num",str(self.getPageNum()))

                cam_cameramod.data.import_obj(obj)
                pass

            
        ###############################
        # END Trylon added support for "point" objects - empty meshes with only a coordinate interface
        ###############################

 
    
    def deldefaultproperty(self,obj,propertyname,defaultvalue):
        try:
            p=obj.getProperty(propertyname)
            if(p.getData() == defaultvalue):
                obj.removeProperty(p)
        except (AttributeError, RuntimeError):
            print "Error removing %s property" % propertyname
        
########
## Material and layer classes are in alc_MatClasses.py
#########


class plAudioInterface(plObjInterface):             #Type 0x11
    def __init__(self,parent,name="unnamed"):
        plObjInterface(self,parent,name,0x0011)
        #Format
        self.audible = UruObjectRef(self.getVersion())
    
    def read(self,stream):
        plObjInterface.read(self,stream)
        self.audible.read(stream)
    
    def write(self,stream):
        plObjInterface.write(self,stream)
        self.audible.write(stream)
    
    def dump(self):
        print "BEGIN plAudioInterface " + self.Key.name
        plObjInterface.dump(self)
        print "plAudible " + self.audible.Key.name
    
    def changePageRaw(self,sid,did,stype,dtype):
        plObjInterface.changePageRaw(self,sid,did,stype,dtype)
        self.audible.changePageRaw(sid,did,stype,dtype)


class plCoordinateInterface(plObjInterface):
    def __init__(self,parent,name="unnamed"):
        plObjInterface.__init__(self,parent,name,0x0015)
        #format
        self.matrix=hsMatrix44() #  <- this one does not make much sense, some objects are correctly placed, and some others not
        self.matrixinv=hsMatrix44()
        self.matrix2=hsMatrix44() # <- everthing seems placed in the correct place, also this seems to be an exact copy
                               # of the matrix found in the spans.
        self.matrix2inv=hsMatrix44()
        self.list=hsTArray([0x01],self.getVersion(),True)

    def changePageRaw(self,sid,did,stype,dtype):
        plObjInterface.changePageRaw(self,sid,did,stype,dtype)
        self.list.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        plObjInterface.read(self,stream)
        assert(self.parentref.Key.object_type==0x01)
        self.matrix.read(stream)
        self.matrixinv.read(stream)
        self.matrix2.read(stream)
        self.matrix2inv.read(stream)
        self.list.ReadVector(stream)


    def write(self,stream):
        if len(self.BitFlags) == 0:
            #initialize bit vector to contain one value: 0
            self.BitFlags.append(0)
        plObjInterface.write(self,stream)
        self.matrix.write(stream)
        self.matrixinv.write(stream)
        self.matrix2.write(stream)
        self.matrix2inv.write(stream)
        self.list.WriteVector(stream)


    def dump(self):
        print "BEGIN CoordinateInterface %s " % self.Key.name
        print "flags %08X, parent: %s" % (self.Flags,self.parentref)
        print "BitFlags: size=%08X" %(len(self.BitFlags))
        for i in self.BitFlags.Data:
            print " %08X" %(i)
        print self.matrix
        print self.matrixinv
        print self.matrix2
        print self.matrix2inv
        print "list %i" %(len(self.list))
        for i in self.list.vector:
            print i
        print "END CoordinateInterface"


    def export_matrices(self,obj):
        m=getMatrix(obj)
        m.transpose()
        self.matrix.set(m) 
        self.matrix2.set(m)
        m=getMatrix(obj)
        m.invert()
        m.transpose()
        self.matrixinv.set(m) 
        self.matrix2inv.set(m)
    def set_matrices(self,localtoworld,localtoparent=None):
        
        l2w = Blender.Mathutils.Matrix(localtoworld)
        w2l = Blender.Mathutils.Matrix(localtoworld)
        w2l.invert()

        if(localtoparent):
            l2p = Blender.Mathutils.Matrix(localtoparent)
            p2l = Blender.Mathutils.Matrix(localtoparent)
            p2l.invert()
        else:
            l2p = Blender.Mathutils.Matrix(l2w)
            p2l = Blender.Mathutils.Matrix(w2l)
        
        l2p.transpose()
        p2l.transpose()
        l2w.transpose()
        w2l.transpose()
        
        self.matrix.set(l2p)
        self.matrixinv.set(p2l)
        self.matrix2.set(l2w)
        self.matrix2inv.set(w2l)
        
         


class plDrawInterface(plObjInterface):
    def __init__(self,parent,name="unnamed"):
        plObjInterface.__init__(self,parent,name,0x0016)
        self.reset()
        self.blenderobjects=[]


    def addSpanSet(self,setnum,spanref):
        self.groups.append(setnum)
        self.spans.append(spanref)


    def changePageRaw(self,sid,did,stype,dtype):
        plObjInterface.changePageRaw(self,sid,did,stype,dtype)
        self.spans.changePageRaw(sid,did,stype,dtype)
        self.vis.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        plObjInterface.read(self,stream)
        self.spans.size = stream.Read32()
        # spans are different than normal UruObjectRef reads, since
        # they have the groups intermingled with the refs
        for i in range(self.spans.size):
            gi = stream.ReadSigned32()
            self.groups.append(gi)
            self.spans.ReadRef(stream)
        self.vis.ReadVector(stream)


    def write(self,stream):
        plObjInterface.write(self,stream)
        stream.Write32(self.spans.size)
        for i in range(self.spans.size):
            stream.WriteSigned32(self.groups[i])
            self.spans[i].update(self.Key)
            self.spans[i].write(stream)
        self.vis.WriteVector(stream)


    def dump(self):
        print "BEGIN DrawInterface %s " % self.Key.name
        print "Flags: %08X, Parent: %s" % (self.Flags,self.parentref)
        print "Set:"
        for i in range(len(self.groups)):
            print "%i - %s" %(self.groups[i],self.spans[i])
        print "Vis: %i" % (len(self.vis))
        for ref in self.vis.vector:
            print ref
        print "END DrawInterface"


    def import_all(self,name=""):
        if name=="":
            name=str(self.Key.name)
        root = self.getRoot()
        for i in range(len(self.groups)):
            group = self.groups[i]
            spanref = self.spans[i]
            spans = root.findref(spanref)
            obj=spans.data.import_object(group,name)
            self.blenderobjects.append(obj)


    def transform(self,matrix):
        matrix=matrix.get()
        matrix.transpose()
        for ob in self.blenderobjects:
            for obj in ob:
                obj.setMatrix(matrix)


    def reset(self):
        self.groups=[]
        if self.getVersion()==6:
            self.spans=hsTArray([0x0049],self.getVersion(),True)
            self.vis=hsTArray([0x00E9],self.getVersion(),True)
        else:
            self.spans=hsTArray([0x004C],self.getVersion(),True)
            self.vis=hsTArray([0x0116],self.getVersion(),True)
        


class plSimulationInterface(plObjInterface):
    plSimulationProperties = \
    { \
        "kDisable"                  :  0, \
        "kWeightless_DEAD"          :  1, \
        "kPinned"                   :  2, \
        "kWarp_DEAD"                :  3, \
        "kUpright_DEAD"             :  4, \
        "kPassive"                  :  5, \
        "kRotationForces_DEAD"      :  6, \
        "kCameraAvoidObject_DEAD"   :  7, \
        "kPhysAnim"                 :  8, \
        "kStartInactive"            :  9, \
        "kNoSynchronize"            : 10, \
        "kSuppressed_DEAD"          : 11, \
        "kNoOwnershipChange"        : 12, \
        "kAvAnimPushable"           : 13, \
        "kNumProps"                 : 14 \
    }
    
    def __init__(self,parent,name="unnamed"):
        plObjInterface.__init__(self,parent,name,0x001C)
        #format
        self.fProps= hsBitVector()
        self.physical=UruObjectRef(self.getVersion()) #plPhysical


    def changePageRaw(self,sid,did,stype,dtype):
        plObjInterface.changePageRaw(self,sid,did,stype,dtype)
        self.physical.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        plObjInterface.read(self,stream)
        self.fProps.read(stream)
        stream.Read32()

        self.physical.read(stream)
        self.physical.verify(self.Key)
        assert(self.physical.Key.object_type==0x3F)


    def write(self,stream):
        plObjInterface.write(self,stream)
        self.fProps.write(stream)
        stream.Write32(0)
        self.physical.write(stream)


    def dump(self):
        print "BEGIN SimulationInterface %s " % self.Key.name
        print "Flags: %08X, Parent: %s" % (self.Flags,self.parentref)
        print "ref %s" %str(self.physical)
        print "END SimulationInterface"

    def import_all(self,name,matrix,blenderObjects):
        root=self.getRoot()
        phys=root.findref(self.physical)
        phys.data.import_all(name,matrix,blenderObjects)


class plSoundBuffer(hsKeyedObject):                     #Type 0x29
    def __init__(self,parent,name="unnamed"):
        hsKeyedObject.__init__(self,parent,name,0x0029)
        #Format
        self.Flags = 0
        self.strLen = 0
        self.oggFile = "" #SafeString
        self.s10 = 0 #WORD Unknown
        self.chans = 0
        self.sampleRate = 0
        self.s18 = 0 #DWORD Unknown
        self.bytesPerTick = 0 #Channels * bitsPerSample / 8 (COBBS)
        self.bitsPerSample = 0 #Usually 16?
    
    def read(self,stream):
        hsKeyedObject.read(self,stream)
        self.Flags = stream.Read32()
        self.strLen = stream.Read32()
        self.oggFile = stream.ReadSafeString()
        self.s10 = stream.Read16()
        self.chans = stream.Read16()
        self.sampleRate = stream.Read32()
        self.s18 = stream.Read32()
        self.bytesPerTick = stream.Read16()
        self.bitsPerSample = stream.Read16()
    
    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.Write32(self.Flags)
        stream.Write32(self.strLen)
        stream.WriteSafeString(self.oggFile)
        stream.Write16(self.s10)
        stream.Write16(self.chans)
        stream.Write32(self.sampleRate)
        stream.Write32(self.s18)
        stream.Write16(self.bytesPerTick)
        stream.Write16(self.bitsPerSample)
    
    def dump(self,stream):
        hsKeyedObject.dump(self)
        print "BEGIN plSoundBuffer " + self.Key.name
        print "OggFile: " + self.oggFile
        print "END plSoundBuffer"


class plSpawnModifier(hsKeyedObject):    
    def __init__(self,parent,name="unnamed"):
        hsKeyedObject.__init__(self,parent,name,0x003D)
        #print "init",pid,ptype
        #format
        self.uk1=0 #U32 = 0
        self.uk2=0


    def changePageRaw(self,sid,did,stype,dtype):
        hsKeyedObject.changePageRaw(self,sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)
        self.uk1, self.uk2 = struct.unpack("II",stream.read(4*2))
        if self.uk1 not in [0x00,]:
            raise "uk1 %08X" %self.uk1
        if self.uk2 not in [0x00,]:
            raise "uk2 %08X" %self.uk2


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.write(struct.pack("II",self.uk1,self.uk2))


    def dump(self):
        print "BEGIN SpawnModifier %s " % self.Key.name
        print "END SpawnModifier"


class plHKPhysical(hsKeyedObject):    
    def __init__(self,parent,name="unnamed"):
        hsKeyedObject.__init__(self,parent,name,0x003F)
        #format
        self.flags=0 #U32 (always)
        self.position=[0.0,0.0,0.0] #position?
        self.orientation=[1.0,0.0,0.0,0.0] #orientation?
        self.mass=0.0 #mass? [if 0, coordinate interface and position are ignored]
        self.rc=10.0 #coefient de fregament?
        self.el=0.0 #Elasticity????
        self.format=4 #U32
        # 0x01 Bounding Box (then there should be only 8 vertexs)
        # 0x02 Bounding Sphere (NPI)
        # 0x03 ConvexHull (no face list) - you must compute it, hah!
        # 0x04 ConcaveMesh - Triangles
        # 0x05 PolygonSoup - Terrain
        self.uk1=0    #U16
        # 0x00 almost always
        # 0x01 TreeDummy02 (sphere02)
        self.type=0x0200   #U16
        # 0x0000 Camera colliders, ConeCollision
        # 0x0002 Nidea (onYeeshaNoGlow)- (was:[avatar don't interacts with collision] [confirm if objects interact or not between them])
        # 0x0100 Kickable object? - enable collision with avatars - save state to disk
        # 0x0200 Physical world? - enable collision with avatars - do not save state to disk
        # 0x0400 Game objects - Region sensor (buttons...) [avatar don't interacts with collision]
        self.flags1=0 #U32
        self.flags2=0x02000000 #U32
        # 0x03840002 - YeeshNoGlow
        # 0x03860000 - Quab
        # 0x03800004 - RollingRock01 (tldnSlaveCave)
        # 0x03840000 - DrWatson (interesting...)
        # 0x03800002 - PhysBoard02 (cleft)
        # 0x01800002 - TreeDummy02 (sphere02)
        # 0x00800000 - no effect?
        # 0x02000000 - enables collision with static objects, and other objects
        # 0x01000000 - no effect?
        self.flags3=0 #U16
        ###if BoundingSphere
        self.a=0 #x?
        self.b=0 #y?
        self.c=0 #z?
        self.d=0 #radius?
        ###else
        self.vertexs=[]
        ###if !ConvexHull
        self.faces=[]
        ###fi
        ###fi
        self.sceneobject=UruObjectRef()
        self.uk2=0x01 #U32 (always)
        self.flags4=0x00000000 #U32
        # 0x0001 kDisable
        # 0x0002 kWeightless
        # 0x0004 kPinned
        # 0x0008 kWarp
        # 0x0010 kUpright
        # 0x0020 kPassive
        # 0x0040 kRotationForces
        # 0x0080 kCameraAvoidObject
        # 0x0100 kPhysAnim
        # 0x0200 kStartInactive
        # 0x0400 kNoSynchronize
        # 0x0800 kSuppressed
        self.scene=UruObjectRef()
        self.uk3=0x00000004 #U32
        # 0x41 - Box06 (tldnHarvest)
        # 0x40 - Dissables friction (between avatars and the collider)
        # 0x20 - Refl1 (tldnHarvest)
        # 0x10 - YeeshaNoGlow
        # 0x08 - wall_blocker_medium
        # 0x04 - Camera doesn't go through object walls.
        # 0x01 - -??
        self.subworld=UruObjectRef()
        self.sndgroup=UruObjectRef()
        self.blendobj = None

    def changePageRaw(self,sid,did,stype,dtype):
        hsKeyedObject.changePageRaw(self,sid,did,stype,dtype)
        self.sceneobject.changePageRaw(sid,did,stype,dtype)
        self.scene.changePageRaw(sid,did,stype,dtype)
        self.subworld.changePageRaw(sid,did,stype,dtype)
        self.sndgroup.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)
        self.flags, = struct.unpack("I",stream.read(4))
        if self.flags not in [0x00,]:
            raise "flags %08X" %self.flags
        f1, f2, f3, f4, f5, f6, f7 = struct.unpack("fffffff",stream.read(4*7))
        self.position=[f1,f2,f3]
        self.orientation=[f4,f5,f6,f7]
        self.mass, self.rc, self.el = struct.unpack("fff",stream.read(4*3))
        self.format, = struct.unpack("I",stream.read(4))
        if self.format not in [0x01,0x02,0x03,0x04,0x05]:
            raise "format %08X" %self.format
        self.uk1, self.type = struct.unpack("HH",stream.read(4))
        if self.uk1 not in [0x00,0x02]:
            raise "uk1 %08X" %self.uk1
        #if self.type not in [0x00,0x02,0x0100,0x0200,0x0400]:
            #raise "type %08X" %self.type
        self.flags1, self.flags2 = struct.unpack("II",stream.read(4*2))
        #if self.flags1 not in [0x00,0x020000,0x800000,0x01000000,0x01020000,0x08000000]:
        #    raise "flags1 %08X" %self.flags1
        #if self.flags2 not in [0x00,0x020000,0x01000000,0x02000000,0x01020000,\
        #                       0x01800002,0x03800000,0x03820000,0x03800002,0x03800004,\
        #                       0x03840000,0x03860000,0x03840002]:
        #    raise "flags2 %08X" %self.flags2
        self.flags3, = struct.unpack("H",stream.read(2))
        #if self.flags3 not in [0x00,0x0101]:
        #    raise "flags3 %08X" %self.flags3
        if self.format==0x02: #BoundingSphere
            self.a, self.b, self.c, self.d = struct.unpack("ffff",stream.read(4*4))
        else:
            count, = struct.unpack("I",stream.read(4))
            for i in range(count):
                x, y, z = struct.unpack("fff",stream.read(4*3))
                vertex = [x,y,z]
                self.vertexs.append(vertex)
            if self.format!=3: #not ConvexHull
                count, = struct.unpack("I",stream.read(4))
                for i in range(count):
                    a, b, c = struct.unpack("HHH",stream.read(2*3))
                    face = [a,b,c]
                    self.faces.append(face)
            else: #convexHull
                #DONE, with the vertexs, build a face list
                c=alcConvexHull(self.vertexs)
                self.vertexs=c.vertexs
                self.faces=c.faces
        self.sceneobject.setVersion(self.getVersion())
        self.sceneobject.read(stream)
        self.sceneobject.verify(self.Key)
        assert(self.sceneobject.Key.object_type==0x01) 
        self.uk2, self.flags4 = struct.unpack("II",stream.read(4*2))
        if self.uk2 not in [0x01,]:
            raise "uk2 %08X" %self.uk2
        #if self.flags4 not in [0x00,0x04,0x10,0x24,0x80,0xA4,0x0100,0x0104,0x0124,0x0184,0x0200,0x300]:
        #    raise "flags4 %08X" %self.flags4
        self.scene.setVersion(self.getVersion())
        self.scene.read(stream)
        self.scene.verify(self.Key)
        assert(self.scene.Key.object_type==0x00)
        self.uk3, = struct.unpack("I",stream.read(4*1))
        if self.uk3 not in [0x00,0x01,0x02,0x04,0x05,0x08,0x20,0x40,0x41,0x44,0x45,0x80]:
            raise "uk3 %08X" %self.uk3
        self.subworld.setVersion(self.getVersion())
        self.subworld.read(stream)
        self.subworld.verify(self.Key)
        self.sndgroup.setVersion(self.getVersion())
        self.sndgroup.read(stream)
        self.sndgroup.verify(self.Key)


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.write(struct.pack("I",self.flags))
        stream.write(struct.pack("fffffff",self.position[0],self.position[1],self.position[2],\
                              self.orientation[0],self.orientation[1],self.orientation[2],self.orientation[3]))
        stream.write(struct.pack("fff",self.mass,self.rc,self.el))
        stream.write(struct.pack("I",self.format))
        stream.write(struct.pack("HH",self.uk1,self.type))
        stream.write(struct.pack("II",self.flags1,self.flags2))
        stream.write(struct.pack("H",self.flags3))
        if self.format==0x02: #BoundingSphere
            stream.write(struct.pack("ffff",self.a,self.b,self.c,self.d))
        else:
            count = len(self.vertexs)
            stream.write(struct.pack("I",count))
            for v in self.vertexs:
                for vi in v:
                    stream.write(struct.pack("f",vi))
            if self.format!=3: #not ConvexHull
                count = len(self.faces)
                stream.write(struct.pack("I",count))
                for f in self.faces:
                    for fi in f:
                        stream.write(struct.pack("H",fi))
        self.sceneobject.write(stream)
        stream.write(struct.pack("II",self.uk2,self.flags4))
        self.scene.write(stream)
        #print self.uk3
        stream.write(struct.pack("I",self.uk3))
        self.subworld.write(stream)
        self.sndgroup.write(stream)


    def dump(self):
        print "BEGIN HKPhysical %s " % self.Key.name
        print "flags %08X" % (self.flags)
        print "Pos: %f %f %f" %(self.position[0],self.position[1],self.position[2])
        print "Ori: %f %f %f %f" %(self.orientation[0],self.orientation[1],self.orientation[2],self.orientation[3])
        print "Mass: %f, rc: %f, el: %f" %(self.mass,self.rc,self.el)
        print "format: %02X, type: %02X" %(self.format,self.type)
        print "flags %08X %08X %08X" %(self.flags1,self.flags2,self.flags3)
        if self.format==2:
            print "Sphere %f %f %f %f" %(self.a,self.b,self.c,self.d)
        else:
            print "%i vertexs, %i faces" %(len(self.vertexs),len(self.faces))
        print "sceneobj %s" %str(self.sceneobject)
        print "flags4 %08X" %(self.flags4)
        print "scene %s" %str(self.scene)
        print "uk3 %08X" %(self.uk3)
        print "subworld %s" %str(self.subworld)
        print "sndgroup %s" %str(self.sndgroup)
        print "END Physical"


    def import_all(self,name,matrix,blenderObjects):
        #the_name=alcUniqueName(name)
        myObjects = blenderObjects
        if self.format in [0x01,0x03,0x04,0x05]:
            if myObjects == None: 
                obj=alcCreateMesh(name,self.vertexs,self.faces)
                m=matrix.get()
                m.transpose()
                obj.setMatrix(m)
                obj.layers=[2,]
                obj.drawType=2
                myObjects = []
                tempList = []
                tempList.append(obj)
                myObjects.append(tempList)
            
            for tempList in myObjects:
                for obj in tempList:            
                    try:
                        p=obj.getProperty("page_num")
                    except (AttributeError, RuntimeError):
                        obj.addProperty("page_num",str(self.getPageNum()))
                    if blenderObjects == None:
                        obj.addProperty("alctype","collider")
                    obj.addProperty("col_type",str(self.format))
                    obj.addProperty("mass",float(self.mass))
                    obj.addProperty("rc",float(self.rc))
                    obj.addProperty("el",float(self.el))
                    obj.addProperty("col_flags0",str(alcHex2Ascii(self.type,2)))
                    obj.addProperty("col_flags1",str(alcHex2Ascii(self.flags1,4)))
                    obj.addProperty("col_flags2",str(alcHex2Ascii(self.flags2,4)))
                    obj.addProperty("col_flags3",str(alcHex2Ascii(self.flags3,2)))
                    obj.addProperty("col_flags4",str(alcHex2Ascii(self.flags4,4)))
                    obj.addProperty("col_flags5",str(alcHex2Ascii(self.uk3,4)))
                    #trylon added to be able to import swimcurrent settings
                    #save the blend object
                    if blenderObjects == None and self.blendobj == None:
                        self.blendobj = obj

  
    def export_object(self,obj,isdynamic=0):
        # get the objects properties if any...
        # if not set ,default to the variables's current setting
        
        self.mass = getFloatPropertyOrDefault(obj,"mass",self.mass)
        self.rc = getFloatPropertyOrDefault(obj,"rc",self.rc)
        self.el = getFloatPropertyOrDefault(obj,"el",self.el)
        self.type = getHexPropertyOrDefault(obj,"col_flags0",2,self.type)
        self.flags1 = getHexPropertyOrDefault(obj,"col_flags1",4,self.flags1)
        self.flags2 = getHexPropertyOrDefault(obj,"col_flags2",4,self.flags2)
        self.flags3 = getHexPropertyOrDefault(obj,"col_flags3",2,self.flags3)
        self.flags4 = getHexPropertyOrDefault(obj,"col_flags4",4,self.flags4)
        self.uk3 = getHexPropertyOrDefault(obj,"col_flags5",4,self.uk3)

        # default to convexHull if type is not in a valid range
        if self.format not in [0x01,0x02,0x03,0x04,0x05,0x06,0x07]:
            self.format=0x03
        if self.format==0x01: #Bounding box
            verts=obj.getBoundBox()
            matrix=hsMatrix44()
            m=getMatrix(obj)
            m.invert()
            m.transpose()
            matrix.set(m)
            #transform to local
            tverts=[]
            for vi in verts:
                v=Vertex(vi[0],vi[1],vi[2])
                v.transform(matrix)
                va=[v.x,v.y,v.z]
                tverts.append(va)
            verts=tverts
            #
            c=alcConvexHull(verts)
            self.vertexs=c.vertexs
            self.faces=c.faces
        elif self.format==0x02: #Bounding sphere
            self.vertexs=[]
            self.faces=[]
            #DONE
            verts=[]
            #transform to world for static objects
            matrix=hsMatrix44()
            m=getMatrix(obj)
            m.transpose()
            matrix.set(m)
            for vert in obj.data.verts:
                #v=Vertex(vert.co[0],vert.co[1],vert.co[2])
                v=[vert.co[0],vert.co[1],vert.co[2]]
                #v.transform(matrix) #slow very slow - user should pass already transformed objects
                #v=[v.x,v.y,v.z]
                verts.append(v)
            max=0
            print "computing distance..."
            for i in verts:
                for e in verts:
                    d=distance(i,e)
                    if d>max:
                        max=d
            self.d=max/2
        elif self.format in [0x03,]: #Convex Hull
            verts=[]
            for vert in obj.data.verts:
                v=[vert.co[0],vert.co[1],vert.co[2]]
                verts.append(v)
            c=alcConvexHull(verts)
            self.vertexs=c.vertexs
            if self.format==0x03:
                self.faces=[]
            else:
                self.faces=c.faces
                self.format=self.format-2
        elif self.format in [0x04,0x05]: #others
            self.vertexs=[]
            self.faces=[]
            for vert in obj.data.verts:
                v=[vert.co[0],vert.co[1],vert.co[2]]
                self.vertexs.append(v)
            for face in obj.data.faces:
                n=len(face.v)
                if n<3:
                    continue
                elif n==3:
                    tface=[]
                    for i in range(3):
                        tface.append(face.v[i].index)
                    self.faces.append(tface)
                elif n==4:
                    tface=[]
                    for i in range(3):
                        tface.append(face.v[i].index)
                    self.faces.append(tface)
                    tface=[]
                    for i in (0,2,3):
                        tface.append(face.v[i].index)
                    self.faces.append(tface)
                else:
                    raise RuntimeError
        #set position and other attribs
        if (self.mass==0 and isdynamic == 0): 
            #transform to world for static objects
            tverts=[]
            matrix=hsMatrix44()
            m=getMatrix(obj)
            m.transpose()
            matrix.set(m)
            for vi in self.vertexs:
                v=Vertex(vi[0],vi[1],vi[2])
                v.transform(matrix)
                va=[v.x,v.y,v.z]
                tverts.append(va)
            self.vertexs=tverts
        else:
            x,y,z = obj.getLocation()
            self.position=[x,y,z]

            m = getMatrix(obj)
            # m.transpose()
            quat = m.toQuat()
            quat.normalize()
            self.orientation = [quat.w,quat.x,quat.y,quat.z]

    def export_synthetic(self,L2Wmatrix,vertex_list,face_list,col_type,isdynamic):
        # set the objects properties to a default region
        
        self.mass  = 1.0
        self.rc    = 0.0
        self.el    = 0.0

        self.type      = 0x0400
        self.flags1    = 0x08000000
        self.flags2    = 0x00000000
        self.flags3    = 0x0000
        self.flags4    = 0x00000004
        self.uk3       = 0x00000000

        self.format = col_type

        # default to convexHull if type is not in a valid range
        if self.format not in [0x03,0x04]:
            self.format=0x03
        elif self.format in [0x03,]: #Convex Hull
            verts=vertex_list
            self.vertexs=c.vertexs
            self.faces=[]
        elif self.format in [0x04,]: #others
            self.vertexs=vertex_list
            self.faces=[]

            for face in face_list:
                n=len(face)
                if n<3:
                    continue
                elif n==3:
                    self.faces.append(face)
                elif n==4:
                    tface=[]
                    for i in range(3):
                        tface.append(face[i])
                    self.faces.append(tface)

                    tface=[]
                    for i in (0,2,3):
                        tface.append(face[i])
                    self.faces.append(tface)
                else:
                    raise "ERROR: faces of more than 5 vertices cannot be handled!"

        #set position and other attribs
        if (self.mass==0 and isdynamic == 0): 
            #transform to world for static objects
            tverts=[]
            matrix=hsMatrix44()
            m=Blender.Mathutils.Matrix(L2Wmatrix)
            m.transpose()
            matrix.set(m)
            for vi in self.vertexs:
                v=Vertex(vi[0],vi[1],vi[2])
                v.transform(matrix)
                va=[v.x,v.y,v.z]
                tverts.append(va)
            self.vertexs=tverts
        else:
            p = L2Wmatrix.translationPart()
            self.position=[p.x,p.y,p.z]

            m = Blender.Mathutils.Matrix(L2Wmatrix)
            # m.transpose()
            quat = m.toQuat()
            quat.normalize()
            self.orientation = [quat.w,quat.x,quat.y,quat.z]
    

class plViewFaceModifier(plSingleModifier):
    plVFFlags = \
    { \
        "kPivotFace"    :  0, \
        "kPivotFavorY"  :  1, \
        "kPivotY"       :  2, \
        "kPivotTumble"  :  3, \
        "kScale"        :  4, \
        "kFaceCam"      :  5, \
        "kFaceList"     :  6, \
        "kFacePlay"     :  7, \
        "kFaceObj"      :  8, \
        "kOffset"       :  9, \
        "kOffsetLocal"  : 10, \
        "kMaxBounds"    : 11  \
    }
    
    
    def __init__(self, parent, name="unnamed", type=0x0040):
        plSingleModifier.__init__(self, parent, name, type)
        self.fScale = Vertex()
        self.fOrigLocalToParent = hsMatrix44()
        self.fOrigParentToLocal = hsMatrix44()
        self.fOffset = Vertex()
        self.fMaxBounds = hsBounds3Ext()
        self.fFaceObj = UruObjectRef(self.getVersion()) 

    def read(self, stream):
        plSingleModifier.read(self,stream)
        self.fScale.read(stream) 
        self.fOrigLocalToParent.read(stream)
        self.fOrigParentToLocal.read(stream)
        if(self.bitVector[plViewFaceModifier.plVFFlags["kFaceObj"]]):
            self.fFaceObj.read(stream)
        self.fOffset.read(stream)
        if(self.bitVector[plViewFaceModifier.plVFFlags["kMaxBounds"]]):
            self.fMaxBounds.read(stream)

    def write(self, stream):
        plSingleModifier.write(self,stream)
        self.fScale.write(stream)
        self.fOrigLocalToParent.write(stream)
        self.fOrigParentToLocal.write(stream)
        if(self.bitVector[plViewFaceModifier.plVFFlags["kFaceObj"]]):
            self.fFaceObj.write(stream)
        self.fOffset.write(stream)
        if(self.bitVector[plViewFaceModifier.plVFFlags["kMaxBounds"]]):
            self.fMaxBounds.write(stream) # only write this if needed
    
    def dump(self):
        plSingleModifier.dump(self)
        print "fScale:",
        print self.fScale
        print "fOffset:",
        print self.fOffset
        print "END plViewFaceModifier"

    def import_obj(self,obj):
        if(self.bitVector.Count > 0):
            obj.addProperty("sprite_flags",str(alcHex2Ascii(self.bitVector.Data[0],4)))
        else:
            obj.addProperty("sprite_flags",str(alcHex2Ascii(0x00,4)))
    
    def export_obj(self,obj,prp):
        try:
            p=obj.getProperty("sprite_flags")
            BVData=alcAscii2Hex(str(p.getData()),4)
        except (AttributeError, RuntimeError):
            BVData = plViewFaceModifer.plVFFlags['kFaceCam']    | \
                     plViewFaceModifer.plVFFlags['kPivotY']     | \
                     plViewFaceModifer.plVFFlags['kPivotFavorY']
            pass
        self.bitVector.append(BVData)

        # get the matrices
        LocalToWorld=hsMatrix44()
        m=getMatrix(obj)
        m.transpose()
        LocalToWorld.set(m)
        self.fOrigLocalToParent = LocalToWorld

        WorldToLocal=hsMatrix44()
        m=getMatrix(obj)
        m.invert() 
        m.transpose()
        WorldToLocal.set(m)
        self.fOrigParentToLocal = WorldToLocal

        #now see if we need to add a bounding box
        if(self.bitVector[plViewFaceModifier.plVFFlags["kMaxBounds"]]):
            # build up a simple bounding box
            # get the object center
            vorigin = Vertex(0,0,0)
            vorigin.transform(LocalToWorld)
    
            # now we need to build up a bounding cube
            # get the objects bounding box
            verts=obj.getBoundBox()
    
            vmin = Vertex(verts[0][0],verts[0][1],verts[0][2])
            vmin.transform(WorldToLocal)
            vmax = Vertex(verts[6][0],verts[6][1],verts[6][2])
            vmax.transform(WorldToLocal)    
            # now determine the largest Delta[XYZ]
            dmax = 0
            dx = vmax.x-vmin.x
            if(dx > dmax):
                dmax = dx
            dy = vmax.y-vmin.y
            if(dy > dmax):
                dmax = dy
            dz = vmax.z-vmin.z
            if(dz > dmax):
                dmax = dz        
        
            # now determine if the box lies withing the origin on X,Y or Z
            if(vmin.x > 0 and vmax.x > 0):
                if(vmin.x > vmax.x):
                    offsetx = vmax.x
                else:
                    offsetx = vmin.x
            elif(vmin.x < 0 and vmax.x < 0):
                if(vmin.x < vmax.x):
                    offsetx = vmax.x
                else:
                    offsetx = vmin.x
            else:
                offsetx = 0
            
            if(vmin.y > 0 and vmax.y > 0):
                if(vmin.y > vmax.y):
                    offsety = vmax.y
                else:
                    offsety = vmin.y
            elif(vmin.y < 0 and vmax.y < 0):
                if(vmin.y < vmax.y):
                    offsety = vmax.y
                else:
                    offsety = vmin.y
            else:
                offsety = 0
            
            if(vmin.z > 0 and vmax.z > 0):
                if(vmin.z > vmax.z):
                    offsetz = vmax.z
                else:
                    offsetz = vmin.z
            elif(vmin.z < 0 and vmax.z < 0):
                if(vmin.z < vmax.z):
                    offsetz = vmax.z
                else:
                    offsetz = vmin.z
            else:
                offsetz = 0
            
            # now determine the approximate minimum distance to the object from the origin
            offsetxy = math.sqrt(math.pow(offsetx,2)+math.pow(offsety,2))
            roffset = math.sqrt(math.pow(offsetz,2)+math.pow(offsetxy,2))
        
            # take the roffset in account with making the bounding cube, and make it slightly 
            # larger than the bare minimum (1.1 times larger)
            
            rmax = ((dmax/2) + roffset) * 1.1
            
            # now build up the new bounding box:
            vmin = Vertex(vorigin.x - rmax,vorigin.y - rmax,vorigin.z - rmax)
            vmax = Vertex(vorigin.x + rmax,vorigin.y + rmax,vorigin.z + rmax)
    
            ##debug## alcCreateMesh("Temp",[[vmin.x,vmin.y,vmin.z],[vmax.x,vmax.y,vmax.z]],[[0,1,0]])
    
            self.fMaxBounds.min = vmin
            self.fMaxBounds.max = vmax
            self.fMaxBounds.flags = 0x01 # a simple bounding box without any other data
        
        self.fScale = Vertex(1,1,1)
        self.fOffset = Vertex(0,0,0)

#list1
class plDirectionalLightInfo(plLightInfo):    
    def __init__(self,parent,name="unnamed",type=0x0055):
        plLightInfo.__init__(self,parent,name,type)
        self.softVolumeParser = None    


    def dump(self):
        print "BEGIN DirectionalLightInfo %s " % self.Key.name
        print "parent: %s" %(str(self.parentref))
        print self.ambient
        print self.diffuse
        print self.specular
        print self.scenenode
        print "softvolref: %s" % self.softvol
        print "END DirectionalLightInfo"


    def import_all(self,name,matrix):
        #the_name=alcUniqueName(name)
        obj=Blender.Object.New("Lamp",name)
        if self.Key.object_type==0x55:
            type="Area"
        elif self.Key.object_type==0x56:
            type="Lamp"
        elif self.Key.object_type==0x57:
            type="Spot"
        else:
            raise "Unknown Lamp type"
        lamp=Blender.Lamp.New(type,name)
        obj.link(lamp)
        scene = Blender.Scene.GetCurrent()
        scene.link(obj)
        obj.data.energy=0.5
        obj.data.dist = 1000 # plasma has no distance limit for these lights, we should reflect that in blender
        m=matrix.get()
        m.transpose()
        obj.setMatrix(m)
        obj.layers=[1,]
        obj.addProperty("page_num",str(self.getPageNum()))
        
        maxval = max(max(self.diffuse.r,self.diffuse.g),self.diffuse.b)
        
        if maxval > 1:
            obj.data.energy = maxval * 0.5
            lamp.R = self.diffuse.r / maxval
            lamp.G = self.diffuse.g / maxval
            lamp.B = self.diffuse.b / maxval
        else:
            obj.data.energy = 1 * 0.5
            lamp.R = self.diffuse.r
            lamp.G = self.diffuse.g
            lamp.B = self.diffuse.b
        
        
        softVolObj = self.getRoot().findref(self.softvol)
        if softVolObj != None:
            obj.addProperty("softvolume",softVolObj.data.getPropertyString(),'STRING')
        return obj


    def export_object(self,obj):
        lamp=obj.data
        
        print " [Light Base]\n";
        
        #set lighting flags
        try:
            p=obj.getProperty("flags")
            name=str(p.getData())
            while len(name)<8:
                name = "0" + name
            b=binascii.unhexlify(str(name))
            l,=struct.unpack(">I",b)
        except (AttributeError, RuntimeError):
            l=0
        self.BitFlags.append(l)
        
        
        # Determine negative lighting....
        if lamp.mode & (Lamp.Modes["Negative"]):
            print "  >>>Negative light<<<"
            R = 0.0 - lamp.R
            G = 0.0 - lamp.G
            B = 0.0 - lamp.B
        else:
            R = lamp.R
            G = lamp.G
            B = lamp.B

        # Plasma has the same Lights as DirectX:
        #
        
        energy = lamp.energy * 2
        
        # Diffuse:
        if lamp.mode & (Lamp.Modes["NoDiffuse"]):
            print "  Diffuse Lighting Disabled";
            self.diffuse=RGBA(0.0,0.0,0.0,1.0,type=1)
        else:
            print "  Diffuse Lighting Enabled";
            self.diffuse=RGBA(R*energy,G*energy,B*energy,1.0,type=1)

        # Specular
        if lamp.mode & (Lamp.Modes["NoSpecular"]):
            print "  Specular Lighting Disabled";
            self.specular=RGBA(0.0,0.0,0.0,1.0,type=1)
        else:
            print "  Specular Lighting Enabled";
            self.specular=RGBA(R*energy,G*energy,B*energy,1.0,type=1)
        
        # Ambient:
        # Light not directly emitted by the light source, but present because of it.

        # If one wants to use a lamp as ambient, disable both diffuse and specular colors
        # Else, it's just set to 0,0,0 aka not used.
        
        if lamp.mode & (Lamp.Modes["NoSpecular"] | Lamp.Modes["NoDiffuse"]):
            print "  Lamp is set as ambient light"
            self.ambient = RGBA(R * energy, G * energy, B * energy,1.0,type=1)
        else:
            self.ambient = RGBA(0.0, 0.0, 0.0, 0.0, type=1)
        
        # Now Calculate the matrix:
        m=getMatrix(obj)
        m.transpose()
        # Note: 
        # In Blender, the Light cannot be moved in local space,
        # so Light To Local is not needed, and can remain a unity matrix.
        # 
        # 
        # self.LightToLocal.set(m)
        # self.LocalToLight.set(m)
        
        self.LightToWorld.set(m)
        m.invert()
        self.WorldToLight.set(m)


        #Set some shadow flags
        if lamp.mode & (Lamp.Modes["RayShadow"]):
            print "  >>> kLPCastShadows <<<"
            self.BitFlags[plLightInfo.kLPCastShadows] = 1
        else:
            print "  >>> !kLPCastShadows <<<"
            self.BitFlags[plLightInfo.kLPCastShadows] = 0
        
        if lamp.mode & (Lamp.Modes["OnlyShadow"]):
            print "  >>> kLPShadowOnly <<<"
            self.BitFlags[plLightInfo.kLPShadowOnly] = 1
        else:
            print "  >>> !kLPShadowOnly <<<"
            self.BitFlags[plLightInfo.kLPShadowOnly] = 0

        
        # Set the soft volume
        propString = None
        try:
            prop = obj.getProperty("softvolume")
            propString = str(prop.getData())
        except:
            pass
        if (propString != None and self.softVolumeParser != None):
            self.softvol = self.softVolumeParser.parseProperty(propString,str(self.Key.name))

#list1
class plOmniLightInfo(plDirectionalLightInfo): #Incorrect, but I guess it can slip   
    def __init__(self,parent,name="unnamed",type=0x0056):
        plDirectionalLightInfo.__init__(self,parent,name,type)
        #format
        self.fAttenConst=1.0
        self.fAttenLinear=0.0
        self.fAttenQuadratic=1.0
        self.fAttenCutoff=10.0


    def changePageRaw(self,sid,did,stype,dtype):
        plDirectionalLightInfo.changePageRaw(self,sid,did,stype,dtype)


    def read(self,stream):
        plDirectionalLightInfo.read(self,stream)
        self.fAttenConst     = stream.ReadFloat()
        self.fAttenLinear    = stream.ReadFloat()
        self.fAttenQuadratic = stream.ReadFloat()
        self.fAttenCutoff    = stream.ReadFloat()

    def write(self,stream):
        plDirectionalLightInfo.write(self,stream)
        stream.WriteFloat(self.fAttenConst)
        stream.WriteFloat(self.fAttenLinear)
        stream.WriteFloat(self.fAttenQuadratic)
        stream.WriteFloat(self.fAttenCutoff)

    def dump(self):
        print "BEGIN OmniLightInfo %s " % self.Key.name
        plDirectionalLightInfo.dump(self)
        print self.fAttenConst
        print self.fAttenLinear
        print self.fAttenQuadratic
        print self.fAttenCutoff
        print "END OmniLightInfo"


    def import_all(self,name,matrix):
        obj=plDirectionalLightInfo.import_all(self,name,matrix)
        obj.data.dist=self.fAttenCutoff
        obj.data.mode = obj.data.mode | Blender.Lamp.Modes["Quad"]
        obj.addProperty("k0",float(self.fAttenConst))
        obj.data.quad1=self.fAttenLinear
        obj.data.quad2=self.fAttenQuadratic
        return obj

    def export_object(self,obj):
        plDirectionalLightInfo.export_object(self,obj)
        lamp=obj.data

        #Experimental Trylon 26/9/07
        
        # To use blenders Half distance lighting setting, the following formula is used:
        # Linear Mode (default):
        # Blender: Intensity = BlenderDistance/(BlenderDistance + d)
        #
        # Quadratic Mode (blender [Quad] setting)
        # 
        # Blender: Intensity = BlenderDistance / (BlenderDistance + (Quad1 * d) + (Quad2 * d*d))
        # 
        # DirectX/Plasma: Intensity = 1 / ( fAttenConstant + fAttenLinear * d + fAttenQuadratic * d*d )
        # 
        # Conversion Yields:
        # fAttenQuadratic   = Quad2/BlenderDistance
        # fAttenLinear      = Quad1/BlenderDistance
        # fAttenConstant    = 1
        # 
        # 
        # Sphere (Sets Cutoff at Distance....)
        #
        #
        # 
        #
        
        print " [OmniLight]\n";
        if lamp.mode & (Lamp.Modes["Quad"]):
            print "  Quadratic Attenuation"
            self.fAttenQuadratic = lamp.quad2/lamp.dist
            self.fAttenLinear = lamp.quad1/lamp.dist
            self.fAttenConstant = 1
        else:
            print "  Linear Attenuation"
            self.fAttenQuadratic = 0.0
            self.fAttenLinear = 1.0/lamp.dist
            self.fAttenConstant = 1
       
        if lamp.mode & (Lamp.Modes["Sphere"]):
            print "  Sphere cutoff mode at %f" % lamp.dist
            self.fAttenCutoff=lamp.dist
        else:
            print "  Long-range cutoff"
            self.fAttenCutoff=lamp.dist * 4
            


        #/Experimental
        
        


#list1
class plSpotLightInfo(plOmniLightInfo):    
    def __init__(self,parent,name="unnamed",type=0x0057):
        plOmniLightInfo.__init__(self,parent,name,type)
        #format
        self.fFalloff=1.0
        self.fSpotInner=0.0
        self.fSpotOuter=0.0


    def read(self,stream):
        plOmniLightInfo.read(self,stream)
        self.fFalloff   = stream.ReadFloat()
        self.fSpotInner = stream.ReadFloat()   
        self.fSpotOuter = stream.ReadFloat()


    def write(self,stream):
        plOmniLightInfo.write(self,stream)
        stream.WriteFloat(self.fFalloff)
        stream.WriteFloat(self.fSpotInner)
        stream.WriteFloat(self.fSpotOuter)


    def dump(self):
        print "BEGIN SpotLightInfo %s " % self.Key.name
        plOmniLightInfo.dump(self)
        print self.fFalloff
        print self.fSpotInner
        print self.fSpotOuter
        print "END SpotLightInfo"


    def import_all(self,name,matrix):
        obj=plOmniLightInfo.import_all(self,name,matrix)
        lamp = obj.data
        obj.addProperty("fFalloff",float(self.fFalloff))

        spotSizeDeg = self.fSpotOuter * 180.0 / 3.1415926536
        lamp.setSpotSize(spotSizeDeg)

        blend=0.0;
        if self.fSpotOuter > 0:
            blend = self.fSpotInner / self.fSpotOuter
        lamp.setSpotBlend(blend)

        return obj

    def export_object(self,obj):
        plOmniLightInfo.export_object(self,obj)
        lamp=obj.data

        print " [SpotLight]"

        # self.fFalloff= getFloatPropertyOrDefault(obj,"fFalloff",self.fFalloff);

        # Calculate the Outer angle of the Spotlight:
        spotSizeDeg = lamp.getSpotSize()
        self.fSpotOuter = spotSizeDeg * 3.1415926536 / 180.0
        
        # Now calculate the angle of the inner spotlight
        #self.fSpotInner = (0.99 - (lamp.spotBlend * 0.98)) * self.fSpotOuter
        self.fSpotInner = lamp.spotBlend * self.fSpotOuter
        
        # Set the falloff to 1.0
        if lamp.mode & (Lamp.Modes["Halo"]):
            print "  Using Halo setting for Spotlight Falloff"
            self.fFallOff = lamp.haloInt
        else:
            self.fFallOff = 1.0
           


#list2
class plAGModifier(plSingleModifier):    
    def __init__(self,parent,name="unnamed"):
        plSingleModifier.__init__(self,parent,name,0x006C)
        #format
        #U32 0
        #U32 0
        self.string = ""

    def read(self,stream):
        plSingleModifier.read(self,stream)
        self.string = stream.ReadSafeString(self.getVersion())


    def write(self,stream):
        plSingleModifier.write(self,stream)
        stream.WriteSafeString(self.string,self.getVersion())

    def dump(self):
        print "BEGIN AGModifier %s " % self.Key.name
        print str(self.string)
        print "END AGModifier"


class plAGMasterMod(hsKeyedObject):    
    def __init__(self,parent,name="unnamed"):
        hsKeyedObject.__init__(self,parent,name,0x006D)
        #format
        #U32 0
        self.str=str32(type=1)
        self.anims=[] #armature anims


    def changePageRaw(self,sid,did,stype,dtype):
        hsKeyedObject.changePageRaw(self,sid,did,stype,dtype)
        for i in self.anims:
            i.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)
        unk1, = struct.unpack("I",stream.read(4))
        ##myst5 unk1: 0x04
        if unk1 not in [0x00,]:
            raise "unk1 %08X" %unk1
        #On tpots always "", on old versions there is something here
        self.str.read(stream)
        if self.getVersion()==6:
            count1, = struct.unpack("H",stream.read(2))
        else:
            count1, = struct.unpack("I",stream.read(4))
        self.anims=[]
        for i in range(count1):
            ref = UruObjectRef(self.getVersion())
            ref.read(stream)
            #print ref, self.Key
            assert(ref.verify(self.Key))
            if ref.Key.object_type not in [0xF1,0xF2]:
                raise "armature anim %08X" %ref.Key.object_type
            self.anims.append(ref)


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.write(struct.pack("I",0))
        self.str.write(stream)
        stream.write(struct.pack("I",len(self.anims)))
        for ref in self.anims:
            ref.update(self.Key)
            ref.write(stream)


    def dump(self):
        print "BEGIN AGMasterMod %s " % self.Key.name
        print str(self.str)
        print "Anims: %i" %(len(self.anims))
        for ref in self.anims:
            print ref
        print "END AGMasterMod"


class plSoftVolume(plRegionBase):               #Type 0x0087 (Uru)
    def __init__(self,parent,name="unnamed",type=0x0087):
        plRegionBase.__init__(self,parent,name,type)
        #Format
        self.i70 = 0
        self.f74 = 1.0
        self.f78 = 0
    
    def read(self,stream):
        plRegionBase.read(self,stream)
        self.i70 = stream.Read32()
        self.f74 = stream.ReadFloat()
        self.f78 = stream.ReadFloat()
    
    
    def write(self,stream):
        plRegionBase.write(self,stream)
        stream.Write32(self.i70)
        stream.WriteFloat(self.f74)
        stream.WriteFloat(self.f78)

    def dump(self):
        plRegionBase.dump(self)
        print "BEGIN plSoftVolume"
        print "i70: %f" %(self.i70)
        print "f74: %f" %(self.f74)
        print "f78: %f" %(self.f78)
        print "END plSoftVolume"


class plSoftVolumeSimple(plSoftVolume):
    def __init__(self,parent,name="unnamed",type=0x0088):
        plSoftVolume.__init__(self,parent,name,type)
        #Format
        self.f80 = 0
        self.VI7C = None #plVolumeIsect instance


    def read(self,stream,size):
        st=stream.tell()
        plSoftVolume.read(self,stream)
        self.f80 = stream.ReadFloat()
        vitype = stream.Read16()
        if (vitype != 0x0000):
            self.VI7C = PrpVolumeIsect(vitype,self.getVersion())
            if self.VI7C.data == None:
                size=size-(stream.tell()-st)
                self.rawdata=cStringIO.StringIO()
                self.rawdata.write(stream.read(size))
                self.rawdata.seek(0)
            else:
                self.VI7C.read(stream)

    def write(self,stream):
        plSoftVolume.write(self,stream)
        stream.WriteFloat(self.f80)
        if self.VI7C == None:
            stream.Write16(0x0000)
        else:
            stream.Write16(self.VI7C.vitype)
            self.VI7C.write(stream)

    def dump(self):
        plSoftVolume.dump(self)
        print "BEGIN SoftVolumeSimple"
        print "f80: %f" %(self.f80)
        print "VI7C: ", self.VI7C.vitype
        print "END SoftVolumeSimple"

    def getPropertyString(self):
        return str(self.Key.name)


    def import_all(self):
        name = str(self.Key.name)
        if self.VI7C.data != None:
            self.VI7C.data.createObject(name,self.getPageNum())
            self.dump()

    def export_object(self,obj):
        # Pass this info to a convect volume isect
        self.VI7C = PrpVolumeIsect(0x02F5,self.getVersion())
        self.VI7C.data.export_object(obj)


class plSoftVolumeComplex(plSoftVolume):
    def __init__(self,parent,name="unnamed",type=0x0089):
        plSoftVolume.__init__(self,parent,name,type)
        #Format
        self.vSV7C = hsTArray([0x88,0x8A,0x8B,0x8C],self.getVersion(),True)

    def read(self,stream):
        plSoftVolume.read(self,stream)
        self.vSV7C.read(stream)

    def write(self,stream):
        plSoftVolume.write(self,stream)
        self.vSV7C.write(stream)

    def getPropertyString(self):
        count = self.vSV7C.size
        if count > 0:
            propertyString = self.getPropertySymbol()
            propertyString += "("
            for i in range(count):
                if i > 0:
                    propertyString += ","
                svRef = self.vSV7C[i]
                softVolume = self.getRoot().findref(svRef)
                if softVolume != None:
                    propertyString += softVolume.data.getPropertyString()
                else:
                    raise RuntimeError, "Could not find soft volume object %s" % str(svRef.Key.name)
            propertyString += ")"
            return propertyString
        return None


class plSoftVolumeUnion(plSoftVolumeComplex):
    def __init__(self,parent,name="unnamed",type=0x008A):
        plSoftVolumeComplex.__init__(self,parent,name,type)

    def getPropertySymbol(self):
        return "U"


class plSoftVolumeIntersect(plSoftVolumeComplex):
    def __init__(self,parent,name="unnamed",type=0x008B):
        plSoftVolumeComplex.__init__(self,parent,name,type)

    def getPropertySymbol(self):
        return "I"


class plSoftVolumeInvert(plSoftVolumeComplex):
    def __init__(self,parent,name="unnamed",type=0x008C):
        plSoftVolumeComplex.__init__(self,parent,name,type)

    def getPropertySymbol(self):
        return "!"


class plLayerLinkAnimation(hsKeyedObject):    
    def __init__(self,parent,name="unnamed"):
        hsKeyedObject.__init__(self,parent,name,0x008E)
        #format
        self.unk1=0x00 #U32 0
        self.layer=UruObjectRef() #0x06
        #U16 0x8000 x4
        self.xword=0x2D
        self.sceneobject=UruObjectRef()


    def changePageRaw(self,sid,did,stype,dtype):
        hsKeyedObject.changePageRaw(self,sid,did,stype,dtype)
        self.layer.changePageRaw(sid,did,stype,dtype)
        self.sceneobject.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)
        unk1,  = struct.unpack("I",stream.read(4))
        if unk1 not in [0x00,]:
            raise "unk1 %08X" %unk1
        self.layer.read(stream)
        if self.layer.Key.object_type not in [0x06,]:
            assert "layer %08X" %(self.layer.Key.object_type)
        for i in range(4):
            word, = struct.unpack("H",stream.read(2))
            assert(word==0x8000)
        word, = struct.unpack("H",stream.read(2))
        assert(word==0x022F)
        for i in range(3):
            word, = struct.unpack("I",stream.read(4))
            assert(word==0x000)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x01)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x02)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x01)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x00)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x00)
        f, = struct.unpack("f",stream.read(4))
        assert(f==100.0)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x01)
        self.xword, = struct.unpack("I",stream.read(4))
        assert(self.xword==0x2D)
        f, = struct.unpack("f",stream.read(4))
        assert(f==1.50)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x00)
        word, = struct.unpack("H",stream.read(2))
        assert(word==0x8000)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x01)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x00)
        f, = struct.unpack("f",stream.read(4))
        assert(f==1.50)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x00)
        word, = struct.unpack("I",stream.read(4))
        assert(word==0x00)
        f, = struct.unpack("f",stream.read(4))
        assert(f==1.0)
        for i in range(3):
            word, = struct.unpack("H",stream.read(2))
            if word not in [0x8000,]:
                raise "word %08X" %(word)
        for i in range(5):
            word, = struct.unpack("I",stream.read(4))
            assert(word==0x000)
        self.sceneobject.read(stream)
        word, = struct.unpack("B",stream.read(1))
        assert(word==0x01)


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.write(struct.pack("I",self.unk1))
        self.layer.write(stream)
        for i in range(4):
            stream.write(struct.pack("H",0x8000))
        stream.write(struct.pack("H",0x022F))
        for i in range(3):
            stream.write(struct.pack("I",0x000))
        stream.write(struct.pack("I",0x01))
        stream.write(struct.pack("I",0x02))
        stream.write(struct.pack("I",0x01))
        stream.write(struct.pack("I",0x00))
        stream.write(struct.pack("I",0x00))
        stream.write(struct.pack("f",100.0))
        stream.write(struct.pack("I",0x01))
        stream.write(struct.pack("I",self.xword))
        stream.write(struct.pack("f",1.50))
        stream.write(struct.pack("I",0x00))
        stream.write(struct.pack("H",0x8000))
        stream.write(struct.pack("I",0x01))
        stream.write(struct.pack("I",0x00))
        stream.write(struct.pack("f",1.50))
        stream.write(struct.pack("I",0x00))
        stream.write(struct.pack("I",0x00))
        stream.write(struct.pack("f",1.0))
        for i in range(3):
            stream.write(struct.pack("H",0x8000))
        for i in range(5):
            stream.write(struct.pack("I",0x000))
        self.sceneobject.write(stream)
        stream.write(struct.pack("B",0x01))
    def dump(self):
        print "BEGIN LayerLinkAnimation %s " % self.Key.name
        print self.layer
        print self.sceneobject
        print "END LayerLinkAnimation"


class plPyArg:
    def __init__(self):
        self.idx=0
        self.type=0
        self.data=None
        self.reflist=(0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0E,0x0F,0x10,0x12,0x13,0x14,0x15)


    def changePageRaw(self,sid,did,stype,dtype):
        if self.type in self.reflist:
            self.data.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        self.idx = stream.Read32()
        self.type = stream.Read32()
        if self.type in (0x01,0x03):
            self.data = stream.Read32()
        elif self.type==0x02:
            self.data = stream.ReadFloat()
        elif self.type in (0x04,0x0D): #str32
            s = str32()
            s.read(stream)
            self.data=s
        elif self.type in self.reflist: #ref
            r = UruObjectRef()
            r.read(stream)
            self.data=r
        else:
            raise RuntimeError, "Unexpected argument type %02X" % self.type


    def write(self,stream):
        stream.Write32(self.idx)
        stream.Write32(self.type)
        if self.type in (0x01,0x03): #int, bool?
            stream.Write32(self.data)
        elif self.type==0x02: #float?
            stream.WriteFloat(self.data)
        elif self.type in (0x04,0x0D): #str32
            self.data.write(stream)
        elif self.type in self.reflist: #ref
            self.data.write(stream)
        else:
            raise RuntimeError, "Unexpected argument type %02X" % self.type


    def __str__(self):
        return "%i-%02X %s" %(self.idx,self.type,str(self.data))


#list2
class plPythonFileMod(plMultiModifier):                              #Type 0xA2
    def __init__(self,parent,name="unnamed"):
        plMultiModifier.__init__(self,parent,name,0x00A2)
        self.PyFile = Ustr(name,self.getVersion()) 
        self.PyFMods = hsTArray()
        self.PyArgs = []
    
    
    def addPyArg(self,idx,dat):
        arg = plPyArg()
        arg.idx = idx
        try:
            int(dat)
            try:
                dat = bool(dat)
                arg.type = 3
            except:
                arg.type = 1
        except:
            try:
                dat = float(dat)
                arg.type = 2
            except:
                try:
                    dat = str(dat)
                    arg.type = 4
                except:
                    del arg
                    print "PyArg" + idx + " has an unsupported datatype. Ignoring."
        if arg != None:
            arg.data = dat
            self.PyArgs.append(arg)
    
    
    def read(self,stream):
        plMultiModifier.read(self,stream)
        #self.PyFile = stream.ReadSafeString()
        self.PyFile.read(stream)
        self.PyFMods.read(stream)
        i = stream.Read32()
        for j in range(i):
            k = plPyArg()
            k.read(stream)
            self.PyArgs.append(k)
    
    
    def write(self,stream):
        plMultiModifier.write(self,stream)
        #stream.WriteSafeString(self.PyFile)
        self.PyFile.setType(self.getVersion())
        self.PyFile.write(stream)
        self.PyFMods.write(stream)
        stream.Write32(len(self.PyArgs))
        for i in range(len(self.PyArgs)):
            self.PyArgs[i].write(stream)
    
    
    def dump(self):
        print "BEGIN PythonFileMod " + self.Key.name
        plMultiModifier.dump(self)
        print "Got " + len(self.PyFMods) + " linked PythonFileMods"
        for i in range(len(slef.PyFMods)):
            print "--> # " + i + " Mod: " + self.PyFMods[i].Key.name
        print len(self.PyArgs) + " arguments passed"



class plMsgForwarder(hsKeyedObject):    
    def __init__(self,parent,name="unnamed"):
        hsKeyedObject.__init__(self,parent,name,0x00A8)
        #format
        self.mods=[] #modifiers


    def changePageRaw(self,sid,did,stype,dtype):
        hsKeyedObject.changePageRaw(self,sid,did,stype,dtype)
        for i in self.mods:
            i.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)
        count1, = struct.unpack("I",stream.read(4))
        self.mods=[]
        for i in range(count1):
            ref = UruObjectRef()
            ref.read(stream)
            ##assert(ref.verify(self.Key))
            if ref.Key.object_type not in [0x6D,]:
                raise "modifier %08X" %ref.Key.object_type
            self.mods.append(ref)


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.write(struct.pack("I",len(self.mods)))
        for ref in self.mods:
            ##ref.update(self.Key)
            ref.write(stream)


    def dump(self):
        print "BEGIN MsgForwarder %s " % self.Key.name
        print "Modifiers: %i" %(len(self.mods))
        for ref in self.mods:
            print ref
        print "END MsgForwarder"


class plArmatureEffectsMgr(hsKeyedObject):    
    def __init__(self,parent,name="unnamed"):
        hsKeyedObject.__init__(self,parent,name,0x00CD)
        #format
        #U32 0


    def changePageRaw(self,sid,did,stype,dtype):
        hsKeyedObject.changePageRaw(self,sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)
        unk1,  = struct.unpack("I",stream.read(4))
        if unk1 not in [0x00,]:
            raise "unk1 %08X" %unk1


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.write(struct.pack("I",0))


    def dump(self):
        print "BEGIN ArmatureEffectsMgr %s " % self.Key.name
        print "END ArmatureEffectsMgr"


#list2


class plATCAnim(hsKeyedObject):    
    def __init__(self,parent,name="unnamed"):
        hsKeyedObject.__init__(self,parent,name,0x00F1)
        #format
        #base U32 0


    def changePageRaw(self,sid,did,stype,dtype):
        hsKeyedObject.changePageRaw(self,sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)


    def write(self,stream):
        hsKeyedObject.write(self,stream)


    def dump(self):
        print "BEGIN ATCAnim %s " % self.Key.name
        print "END ATCAnim"


#list2
class plPanicLinkRegion(hsKeyedObject):    
    def __init__(self,parent,name="unnamed"):
        hsKeyedObject.__init__(self,parent,name,0x00FC)
        #format
        self.uk1=0 #U32 = 0
        self.uk2=0
        self.uk3=0
        self.uk4=0x10000000


    def changePageRaw(self,sid,did,stype,dtype):
        hsKeyedObject.changePageRaw(self,sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)
        self.uk1, self.uk2, self.uk3, self.uk4 = struct.unpack("IIII",stream.read(4*4))
        if self.uk1 not in [0x00,]:
            raise "uk1 %08X" %self.uk1
        if self.uk2 not in [0x00,]:
            raise "uk2 %08X" %self.uk2
        if self.uk3 not in [0x00,]:
            raise "uk3 %08X" %self.uk3
        if self.uk4 not in [0x01000000,0x10000000]:
            raise "uk4 %08X" %self.uk4


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.write(struct.pack("IIII",self.uk1,self.uk2,self.uk3,self.uk4))


    def dump(self):
        print "BEGIN PanicLinkRegion %s " % self.Key.name
        print "END PanicLinkRegion"


#list2
class plSwimRegion(hsKeyedObject):    
    def __init__(self,parent,name="unnamed"):
        hsKeyedObject.__init__(self,parent,name,0x012E)
        #format
        self.uk1=0 #U32 = 0
        self.uk2=0 #U32
        self.uk3=0x01 #Byte
        self.uk4=0x0451 #U16
        self.parentref=UruObjectRef() #sceneobject
        self.uk5=0x00 #U32
        self.uk6=0x00 #U32
        self.uk7=0x00 #U32
        self.uk8=0x0810 #U32
        self.uk9=0x01 #Byte
        self.myself=UruObjectRef() #a ref to ME?
        self.uk10=0x01 #Byte
        self.uk11=0x0451 #U16
        self.parentref2=UruObjectRef()
        self.uk12=0x00 #U32
        self.uk13=0x00 #U32
        self.uk14=0x00 #U32
        self.uk15=0x0810 #U32
        self.uk16=0x00 #Byte
        self.myself2=UruObjectRef() #a ref to ME?
        self.uk17=0x00 #U32
        self.uk18=0x00 #U32
        self.uk19=0x00 #Byte


    def changePageRaw(self,sid,did,stype,dtype):
        hsKeyedObject.changePageRaw(self,sid,did,stype,dtype)
        self.parentref.changePageRaw(sid,did,stype,dtype)
        self.myself.changePageRaw(sid,did,stype,dtype)
        self.parentref2.changePageRaw(sid,did,stype,dtype)
        self.myself2.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)
        self.uk1, self.uk2 = struct.unpack("II",stream.read(4*2))
        self.uk3, = struct.unpack("B",stream.read(1))
        self.uk4, = struct.unpack("H",stream.read(2))
        if self.uk1 not in [0x00,]:
            raise "uk1 %08X" %self.uk1
        if self.uk2 not in [0x00,]:
            raise "uk2 %08X" %self.uk2
        if self.uk3 not in [0x01,]:
            raise "uk3 %08X" %self.uk3
        if self.uk4 not in [0x0451,]:
            raise "uk4 %08X" %self.uk4
        self.parentref.read(stream)
        self.uk5, self.uk6, self.uk7, self.uk8 = struct.unpack("IIII",stream.read(4*4))
        self.uk9, = struct.unpack("B",stream.read(1))
        if self.uk5 not in [0x00,]:
            raise "uk5 %08X" %self.uk5
        if self.uk6 not in [0x00,]:
            raise "uk6 %08X" %self.uk6
        if self.uk7 not in [0x00,]:
            raise "uk7 %08X" %self.uk7
        if self.uk8 not in [0x0810,]:
            raise "uk8 %08X" %self.uk8
        if self.uk9 not in [0x01,]:
            raise "uk9 %08X" %self.uk9
        self.myself.read(stream)
        self.uk10, = struct.unpack("B",stream.read(1))
        self.uk11, = struct.unpack("H",stream.read(2))
        if self.uk10 not in [0x01,]:
            raise "uk10 %08X" %self.uk10
        if self.uk11 not in [0x0451,]:
            raise "uk11 %08X" %self.uk11
        self.parentref2.read(stream)
        self.uk12, self.uk13, self.uk14, self.uk15 = struct.unpack("IIII",stream.read(4*4))
        self.uk16, = struct.unpack("B",stream.read(1))
        if self.uk12 not in [0x00,]:
            raise "uk12 %08X" %self.uk12
        if self.uk13 not in [0x00,]:
            raise "uk13 %08X" %self.uk13
        if self.uk14 not in [0x00,]:
            raise "uk14 %08X" %self.uk14
        if self.uk15 not in [0x0810,]:
            raise "uk15 %08X" %self.uk15
        if self.uk16 not in [0x00,]:
            raise "uk16 %08X" %self.uk16
        self.myself2.read(stream)
        self.uk17, self.uk18 = struct.unpack("II",stream.read(4*2))
        self.uk19, = struct.unpack("B",stream.read(1))
        if self.uk17 not in [0x00,]:
            raise "uk17 %08X" %self.uk17
        if self.uk18 not in [0x00,]:
            raise "uk18 %08X" %self.uk18
        if self.uk19 not in [0x00,]:
            raise "uk19 %08X" %self.uk19


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.write(struct.pack("II",self.uk1,self.uk2))
        stream.write(struct.pack("B",self.uk3))
        stream.write(struct.pack("H",self.uk4))
        self.parentref.write(stream)
        stream.write(struct.pack("IIII",self.uk5,self.uk6,self.uk7,self.uk8))
        stream.write(struct.pack("B",self.uk9))
        self.myself.write(stream)
        stream.write(struct.pack("B",self.uk10))
        stream.write(struct.pack("H",self.uk11))
        self.parentref2.write(stream)
        stream.write(struct.pack("IIII",self.uk12,self.uk13,self.uk14,self.uk15))
        stream.write(struct.pack("B",self.uk16))
        self.myself2.write(stream)
        stream.write(struct.pack("B",self.uk17))
        stream.write(struct.pack("II",self.uk18,self.uk19))


    def dump(self):
        print "BEGIN SwimRegion %s " % self.Key.name
        print self.parentref
        print self.myself
        print self.parentref2
        print self.myself2
        print "END SwimRegion"


#list1
class plSwimRegionInterface(hsKeyedObject):    
    def __init__(self,parent,name="unnamed",type=0x0133):
        hsKeyedObject.__init__(self,parent,name,type)
        #format
        self.uk1=0 #U32 = 0
        self.parentref=UruObjectRef() #sceneobject
        self.if1=0.0
        self.if2=11.0
        self.if3=2.0
        self.if4=5.0


    def changePageRaw(self,sid,did,stype,dtype):
        hsKeyedObject.changePageRaw(self,sid,did,stype,dtype)
        self.parentref.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        hsKeyedObject.read(self,stream)
        self.uk1, = struct.unpack("I",stream.read(4*1))
        if self.uk1 not in [0x00,]:
            raise "uk1 %08X" %self.uk1
        self.parentref.read(stream)
        self.if1, self.if2, self.if3, self.if4 = struct.unpack("ffff",stream.read(4*4))


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.write(struct.pack("I",self.uk1))
        self.parentref.write(stream)
        stream.write(struct.pack("ffff",self.if1,self.if2,self.if3,self.if4))


    def dump(self):
        print "BEGIN SwimRegionInterface %s " % self.Key.name
        print self.parentref
        print "END SwimRegionInterface"


    def import_obj(self,obj):
        pass
    
    def export_obj(self,obj):
            pass


#list1
class plSwimCircularCurrentRegion(plSwimRegionInterface):    
    def __init__(self,parent,name="unnamed"):
        plSwimRegionInterface.__init__(self,parent,name,0x0134)
        #format
        self.f1=-4.0
        self.f2=1.0
        self.f3=2.0
        self.f4=1.0
        self.f5=2.0
        self.dummy=UruObjectRef() # seems to be a sceneobject with only a coordinate interface


    def changePageRaw(self,sid,did,stype,dtype):
        plSwimRegionInterface.changePageRaw(self,sid,did,stype,dtype)
        self.dummy.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        plSwimRegionInterface.read(self,stream)
        self.f1, self.f2, self.f3, self.f4, self.f5 = struct.unpack("fffff",stream.read(4*5))
        ### Inner, Left, Right
        #if self.f1 not in [-4.0,6.0,-6.0]:
        #    raise "f1 %f" %self.f1
        #if self.f2 not in [1.0,25600.0]:
        #    raise "f2 %f" %self.f2
        #if self.f3 not in [2.0,]:
        #    raise "f3 %f" %self.f3
        #if self.f4 not in [1.0,34596.0]:
        #    raise "f4 %f" %self.f4
        #if self.f5 not in [2.0,8.0]:
        #    raise "f5 %f" %self.f5
        self.dummy.read(stream)


    def write(self,stream):
        plSwimRegionInterface.write(self,stream)
        stream.write(struct.pack("fffff",self.f1,self.f2,self.f3,self.f4,self.f5))
        self.dummy.write(stream)


    def dump(self):
        print "BEGIN SwimCircularCurrentRegion %s " % self.Key.name
        plSwimRegionInterface.dump(self)
        print self.dummy
        print "END SwimCircularCurrentRegion"


    def import_obj(self,obj):
        plSwimRegionInterface.import_obj(self,obj)
        obj.addProperty("Centerpoint",str(self.dummy.Key.name))
        obj.addProperty("Rotation",float(self.f1))
#        obj.addProperty("swimsfc_f2",float(self.f2))
#        obj.addProperty("swimsfc_f3",float(self.f3))
#        obj.addProperty("swimsfc_f4",float(self.f4))
        obj.addProperty("Attraction",float(self.f5))
        pass


    def export_obj(self,obj,prp):
        plSwimRegionInterface.export_obj(self,obj)
        # import old-style names (for comaptibility
        self.f1 = getFloatPropertyOrDefault(obj,"swimsfc_f1",self.f1)
        self.f2 = getFloatPropertyOrDefault(obj,"swimsfc_f2",self.f2)
        self.f3 = getFloatPropertyOrDefault(obj,"swimsfc_f3",self.f3)
        self.f4 = getFloatPropertyOrDefault(obj,"swimsfc_f4",self.f4)
        self.f5 = getFloatPropertyOrDefault(obj,"swimsfc_f5",self.f5)
        
        # now read in new-style properties
        self.f1 = getFloatPropertyOrDefault(obj,"Rotation",self.f1)
        self.f5 = getFloatPropertyOrDefault(obj,"Attraction",self.f5)
        
        #try readin in old-style dummyname before doing newstyle
        dummyname = getTextPropertyOrDefault(obj,"currentdummy",None)
        dummyname = getTextPropertyOrDefault(obj,"Centerpoint",dummyname)
                
        if(dummyname != None):
            # find or create the dummy
            dummyobj = prp.find(0x0001,dummyname,0)
            if dummyobj == None:
                raise RuntimeError, "Could not locate a swim center object named %s" % dummyname                     
            self.dummy = dummyobj.data.getRef()
        else:
            raise RuntimeError, "Could not locate a swim center object named %s" % dummyname                     


#list1
class plSwimStraightCurrentRegion(plSwimRegionInterface):    
    def __init__(self,parent,name="unnamed"):
        plSwimRegionInterface.__init__(self,parent,name,0x0136)
        #format
        self.f2=160.0
        self.f3=2.0
        self.f4=186.0
        self.f5=8.0
        self.dummy=UruObjectRef()


    def changePageRaw(self,sid,did,stype,dtype):
        plSwimRegionInterface.changePageRaw(self,sid,did,stype,dtype)
        self.dummy.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        plSwimRegionInterface.read(self,stream)
        self.f2, self.f3, self.f4, self.f5 = struct.unpack("ffff",stream.read(4*4))
        ### Center
        #if self.f2 not in [160.0,]:
        #    raise "f2 %f" %self.f2
        #if self.f3 not in [2.0,]:
        #    raise "f3 %f" %self.f3
        #if self.f4 not in [186.0,]:
        #    raise "f4 %f" %self.f4
        #if self.f5 not in [8.0,]:
        #    raise "f5 %f" %self.f5
        self.dummy.read(stream)


    def write(self,stream):
        plSwimRegionInterface.write(self,stream)
        stream.write(struct.pack("ffff",self.f2,self.f3,self.f4,self.f5))
        self.dummy.write(stream)


    def dump(self):
        print "BEGIN SwimStraightCurrentRegion %s " % self.Key.name
        plSwimRegionInterface.dump(self)
        print self.dummy
        print "END SwimStraightCurrentRegion"


    def import_obj(self,obj):
        plSwimRegionInterface.import_obj(self,obj)
        obj.addProperty("Centerpoint",str(self.dummy.Key.name))
        #obj.addProperty("swimsfc_f2",float(self.f2))
        obj.addProperty("Y-Speed",float(self.f3))
        #obj.addProperty("swimsfc_f4",float(self.f4))
        obj.addProperty("Y+Speed",float(self.f5))


    def export_obj(self,obj,prp):
        plSwimRegionInterface.export_obj(self,obj)
        # import old-style names (for comaptibility
        self.f2 = getFloatPropertyOrDefault(obj,"swimsfc_f2",self.f2)
        self.f3 = getFloatPropertyOrDefault(obj,"swimsfc_f3",self.f3)
        self.f4 = getFloatPropertyOrDefault(obj,"swimsfc_f4",self.f4)
        self.f5 = getFloatPropertyOrDefault(obj,"swimsfc_f5",self.f5)
        
        # now read in new-style properties
        self.f3 = getFloatPropertyOrDefault(obj,"Y-Speed",self.f3)
        self.f5 = getFloatPropertyOrDefault(obj,"Y+Speed",self.f5)
        
        #try readin in old-style dummyname before doing newstyle
        dummyname = getTextPropertyOrDefault(obj,"currentdummy",None)
        dummyname = getTextPropertyOrDefault(obj,"Centerpoint",dummyname)
                
        if(dummyname != None):
            # find or create the dummy
            dummyobj = prp.find(0x0001,dummyname,0)
            if dummyobj == None:
                raise RuntimeError, "Could not locate a swim center object named %s" % dummyname                     
            self.dummy = dummyobj.data.getRef()
        else:
            raise RuntimeError, "Could not locate a swim center object named %s" % dummyname                     


# possible  condition for a logicmodifier.
class plObjectInBoxConditionalObject(plConditionalObject):    
    def __init__(self,parent,name="unnamed",type=0x0037):
        plConditionalObject.__init__(self,parent,name,type)


# TEFSI tested - quality: adequate @ 11 jan 2006
class plVolumeSensorConditionalObject(plConditionalObject):    
    Type = \
    { \
        "kTypeEnter" : 0x1,\
        "kTypeExit"  : 0x2 \
    }

    def __init__(self,parent,name="unnamed",type=0x00A6):
        plConditionalObject.__init__(self,parent,name,type)
        #format
        self.fTrigNum=1 #
        self.fType=1 #
        self.fFirst = 0# Bool 


    def changePageRaw(self,sid,did,stype,dtype):
        plConditionalObject.changePageRaw(self,sid,did,stype,dtype)


    def read(self,stream):
        plConditionalObject.read(self,stream)
            
        self.fTrigNum = stream.Read32()
        self.fType = stream.Read32() # Was "direction"
        self.fFirst = stream.ReadByte()


    def write(self,stream):
        hsKeyedObject.write(self,stream)
        stream.Write32(self.fTrigNum)
        stream.Write32(self.fType)
        stream.WriteBool(self.fFirst)

    def import_obj(self,obj):
        pass

    def export_obj(self,obj,prp):
        pass


    def dump(self):
        print "BEGIN ObjectInBoxCondtionalObject %s " % self.Key.name
        if (self.fType == plVolumeSensorConditionalObject.Type["kTypeEnter"]):
            print "fType: kTypeEnter"
        elif (self.fType == plVolumeSensorConditionalObject.Type["kTypeExit"]):
            print "fType: kTypeExit"
        else:
            print "Direction: ILLEGAL?? VALUE"
        print "END ObjectInBoxCondtionalObject"


class plObjectInVolumeDetector(plCollisionDetector):    
    def __init__(self,parent,name="unnamed"):
        plCollisionDetector.__init__(self,parent,name,0x007B)

    def read(self,stream):
        plCollisionDetector.read(self,stream)


    def write(self,stream):
        plCollisionDetector.write(self,stream)
        

class plObjectInVolumeAndFacingDetector(plObjectInVolumeDetector): # type 0x00E7

    def __init__(self,parent,name="unnamed"):
        plObjectInVolumeDetector.__init__(self,parent,name,0x00E7)
        self.fFacingTolerance = 0.1 # probably in radians, so give a bit of an edge
        self.fNeedWalkingForward = 0 # let's default to no walking forward needed

    def read(self,stream):
        plObjectInVolumeDetector.read(self,stream)
        self.fFacingTolerance = stream.ReadFloat()
        self.fNeedWalkingForward = stream.ReadByte()


    def write(self,stream):
        plObjectInVolumeDetector.write(self,stream)
        stream.WriteFloat(self.fFacingTolerance)
        stream.WriteByte(self.fNeedWalkingForward)

        

#TYPE 002D - LogicModifier
class plLogicModifier(plLogicModBase):   
    def __init__(self,parent,name="unnamed"):
        plLogicModBase.__init__(self,parent,name,0x002D)
        #format
        self.Conditionals = hsTArray([0x32,0x37,0x3E,0xA6],self.getVersion(),True)
        self.fMyCursor = 1 #U32 - 1 or 5 defaults to 1


    def changePageRaw(self,sid,did,stype,dtype):
        plLogicModBase.changePageRaw(self,sid,did,stype,dtype)

    def read(self,stream):
        plLogicModBase.read(self,stream)
        self.Conditionals.read(stream)
        self.fMyCursor = stream.Read32()

    def write(self,stream):
        plLogicModBase.write(self,stream)
        self.Conditionals.write(stream)
        stream.Write32(self.fMyCursor)


    def dump(self):
        print "BEGIN LogicModifier %s " % self.Key.name
        print "END LogicModifier"


class plPickingDetector(plDetectorModifier):                    #Type 0x002B
    def __init__(self,parent,name="unnamed"):
        #Gotta figure out how to pass the correct type from M5
        #self.getVersion() & plDectorModifier.getVersion() puke :\
        plDetectorModifier.__init__(self,parent,name,0x002B)


    def dump(self):
        plDetectorModifier.dump(self)
        print "BEGIN PickingDetector " + self.Key.name
        for logic in self.logic.Vector:
            print "LogicModifier: " + logic.Key.name
        print "END PickingDetector"


class plActivatorConditionalObject(plConditionalObject):
    def __init__(self,parent,name="unnamed"):
        plConditionalObject.__init__(self,parent,name,0x0032)
        #format
        self.condobjs = hsTArray()


    def changePageRaw(self,sid,did,stype,dtype):
        plConditionalObject.changePageRaw(self,sid,did,stype,dtype)
        self.condobjs.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        plConditionalObject.read(self,stream)
        self.condobjs.ReadVector(stream)

 
    def write(self,stream):
        plConditionalObject.write(self,stream)
        self.condobjs.update(self.Key)
        self.condobjs.WriteVector(stream)


    def dump(self):
        print "BEGIN ActivatorConditionalObject %s " % self.Key.name
        plConditionalObject.dump(self)
        print "PickingDetector:",
        print self.pickdetect
        print "END ActivatorConditionalObject"


# TEFSI tested - quality: adequate @ 11 jan 2006
class plInterfaceInfoModifier(plSingleModifier):    
    def __init__(self,parent,name="unnamed"):
        plSingleModifier.__init__(self,parent,name,0x00CB)
        #format
        self.objects=hsTArray([0x2D],self.getVersion()) # modifiers Type 2D (LogicModifier) 
        ####


    def changePageRaw(self,sid,did,stype,dtype):
        plSingleModifier.changePageRaw(self,sid,did,stype,dtype)
        self.objects.changePageRaw(sid,did,stype,dtype)


    def read(self,stream):
        plSingleModifier.read(self,stream)
        self.objects.read(stream)


    def write(self,stream):
        plSingleModifier.write(self,stream)
        self.objects.update(self.Key)
        self.objects.write(stream)


    def dump(self):
        print "BEGIN InterfaceInfoModifier %s " % self.Key.name
        print "Refs: %i" %(len(self.objects))
        for ref in self.objects.vector:
            print ref
        print "END InterfaceInfoModifier"


class plFacingConditionalObject(plConditionalObject):
    def __init__(self,parent,name = "unnamed"):
        plConditionalObject.__init__(self,parent,name,0x3E)
        self.fTolerance = -1.0
        self.fDirectional = 0


    def read(self,stream):
        plConditionalObject.read(self,stream)
        self.fTolerance = stream.ReadFloat()
        self.fDirectional = stream.ReadBool()

 
    def write(self,stream):
        plConditionalObject.write(self,stream)
        stream.WriteFloat(self.fTolerance)
        stream.WriteBool(self.fDirectional)



class plShadowMaster(plObjInterface):    # Type: 0x00D3
    plDrawProperties = \
    { \
        "kDisable"      : 0,\
        "kSelfShadow"   : 1, \
        "kNumProps"     : 2  \
    }
    
    def __init__(self,parent,name="unnamed",type=0x00D3):
        plObjInterface.__init__(self,parent,name,type)
        self.fAttenDist = 20.0
        self.fMaxDist = 0.0
        self.fMinDist = 0.0
        self.fMaxSize = 255
        self.fMinSize = 255
        self.fPower = 2.0

    def changePageRaw(self,sid,did,stype,dtype):
        plObjInterface.changePageRaw(self,sid,did,stype,dtype)


    def read(self,stream):
        plObjInterface.read(self,stream)

        self.fAttenDist = stream.ReadFloat()
        self.fMaxDist = stream.ReadFloat()
        self.fMinDist = stream.ReadFloat()
        self.fMaxSize = stream.Read32()
        self.fMinSize = stream.Read32()
        self.fPower = stream.ReadFloat()


    def write(self,stream):
        plObjInterface.write(self,stream)

        stream.WriteFloat(self.fAttenDist)
        stream.WriteFloat(self.fMaxDist)
        stream.WriteFloat(self.fMinDist)
        stream.Write32(self.fMaxSize)
        stream.Write32(self.fMinSize)
        stream.WriteFloat(self.fPower)

    def import_obj(self,obj):
        lamp = obj.data
        
        lamp.mode |= Blender.Lamp.Modes["RayShadow"]

    def export_obj(self,obj):
        lamp = obj.data
        
        print " [ShadowMaster]"        
        
        pass
        
    def dump(self):
        pass

class plShadowCaster(plMultiModifier):    #Type 0x00D4
    Flags = \
    { \
        "kNone"         : 0, \
        "kSelfShadow"   : 0x1, \
        "kPerspective"  : 0x2, \
        "kLimitRes"     : 0x4  \
    }
    def __init__(self,parent,name="unnamed",type=0x00D4):
        plMultiModifier.__init__(self,parent,name,type)

        self.fCastFlags = plShadowCaster.Flags["kNone"]
        self.fBoost = 1.5       # 1.0 (probable default)
        self.fAttenScale = 1    # 1.0 (probable default)
        self.fBlurScale = 0.3   # 0.0 (probable default)


    def changePageRaw(self,sid,did,stype,dtype):
        plMultiModifier.changePageRaw(self,sid,did,stype,dtype)

    def read(self,stream):
        plMultiModifier.read(self,stream)

        self.fCastFlags = stream.ReadByte() & ~plShadowCaster.Flags["kPerspective"]
        self.fBoost = stream.ReadFloat();
        self.fAttenScale = stream.ReadFloat();
        self.fBlurScale = stream.ReadFloat();


    def write(self,stream):
        plMultiModifier.write(self,stream)

        stream.WriteByte(self.fCastFlags);
        stream.WriteFloat(self.fBoost);
        stream.WriteFloat(self.fAttenScale);
        stream.WriteFloat(self.fBlurScale);

    def dump(self):
        print "BEGIN ShadowCaster %s " % self.Key.name
        print "END ShadowCaster"

    def export_obj(self,obj):
        print " [ShadowCaster]"
        self.fCastFlags = plShadowCaster.Flags["kSelfShadow"]
        pass
    
class plPointShadowMaster(plShadowMaster):    # Type: 0x00D5
    def __init__(self,parent,name="unnamed",type=0x00D5):
        plShadowMaster.__init__(self,parent,name,type)


    def changePageRaw(self,sid,did,stype,dtype):
        plShadowMaster.changePageRaw(self,sid,did,stype,dtype)


    def read(self,stream):
        plShadowMaster.read(self,stream)


    def write(self,stream):
        plShadowMaster.write(self,stream)

    def dump(self):
        plShadowMaster.dump(self)

class plDirectShadowMaster(plShadowMaster):    # Type: 0x00D6
    def __init__(self,parent,name="unnamed",type=0x00D6):
        plShadowMaster.__init__(self,parent,name,type)


    def changePageRaw(self,sid,did,stype,dtype):
        plShadowMaster.changePageRaw(self,sid,did,stype,dtype)


    def read(self,stream):
        plShadowMaster.read(self,stream)


    def write(self,stream):
        plShadowMaster.write(self,stream)

    def dump(self):
        plShadowMaster.dump(self)


class plAvLadderMod(plSingleModifier):
    #Rewritten at Oct/11/2006
    def __init__(self,parent,name="unnamed"):
        plSingleModifier.__init__(self,parent,name,0x00B2)
        #format
        self.climbOffset=0 #U32
        self.climbHeight=0 #U32 
        self.bottomFlag=0
        self.byte0=0x01
        self.Direction = Vertex()

    def changePageRaw(self,sid,did,stype,dtype):
        plSingleModifier.changePageRaw(self,sid,did,stype,dtype)


    def read(self,stream):
        plSingleModifier.read(self,stream)
        self.climbOffset = stream.Read32()
        self.climbHeight = stream.Read32()
        self.bottomFlag = stream.ReadByte()
        self.byte0 = stream.ReadByte()
        self.Direction.read(stream)
        


    def write(self,stream):
        plSingleModifier.write(self,stream)
        stream.Write32(self.climbOffset)
        stream.Write32(self.climbHeight)
        stream.WriteByte(self.bottomFlag)
        stream.WriteByte(self.byte0)
        self.Direction.write(stream)

    def dump(self):
        print "BEGIN AvLadderMod %s " % self.Key.name
        print "climbOffset: %i" %(self.climbOffset)
        print "climbHeight: %i" %(self.climbHeight)
        print "bottomFlag: %02X " %(self.bottomFlag)
        print "Direction: (%f,%f,%f) " %(self.fDirectionX,self.fDirectionY)
        print "END AvLadderMod"


    def import_obj(self,obj):
        obj.addProperty("bottomFlag",str(alcHex2Ascii(self.bottomFlag,1)))
        obj.addProperty("climbOffset",int(self.climbOffset))
        obj.addProperty("climbHeight",int(self.climbHeight))
 
    def export_obj(self,obj,prp):
        try:
            p=obj.getProperty("bottomFlag")
            self.bottomFlag=alcAscii2Hex(str(p.getData()),1)
        except (AttributeError, RuntimeError):
            pass
        try:
            p=obj.getProperty("climbOffset")
            self.climbOffset=int(p.getData())
        except (AttributeError, RuntimeError):
             pass
        try:
            p=obj.getProperty("climbHeight")
            self.climbHeight=int(p.getData())
        except (AttributeError, RuntimeError):
            pass
        
        matrix = getMatrix(obj)
        rotMatrix = matrix.rotationPart().resize4x4()

        # calculate the approximate Direction vector
        v = Blender.Mathutils.Vector(0,-1,0,1) # vector describing -Y axis
        v = v * rotMatrix  # transform the vector accoring to object's rotation matrix
        self.Direction.setVector(v) # assign to Direction Vector

        print "Direction: (%f, %f, %f)" % (self.Direction.x,self.Direction.y,self.Direction.z)
    
    def export_synthetic(self,matrix,climbheight,climboffset,isBottom=0):
        
        self.climbHeight = climbheight
        self.climbOffset = climboffset
        self.bottomFlag = isBottom
        
        # calculate the approximate Direction vector
        rotMatrix = matrix.rotationPart().resize4x4()
        v = Blender.Mathutils.Vector(0,-1,0,1) # vector describing -Y axis
        v = v * rotMatrix  # transform the vector accoring to object matrix
        self.Direction.setVector(v) # assign to Direction Vector



class plDynaDecalMgr(plSynchedObject):    
    def __init__(self,parent,name="unnamed",type=0x00E6):
        plSynchedObject.__init__(self,parent,name,type)
        #format
        self.mat1 = UruObjectRef()
        self.mat2 = UruObjectRef()
        
        self.SO1Count
        self.SceneObjects1 = []
        self.SO2Count
        self.SceneObjects2 = []

        self.sA0 = 0x000003E8
        self.sA2 = 0x000003E8
        self.iA4 = 0x00000000

        self.fD0 = 0.0   # fB8 = fD0

        self.fA8
        self.fAC
        self.fB0
        self.fB4
        self.fBC
        self.fC0
        
        self.VC4 = Vertex()
        self.f9C
        
        self.iMsgCount
        self.vMEC = [] # plMessage[MsgCount]


class plHardRegionPlanes(plRegionBase):
    def __init__(self,parent,name="unnamed",type=0x0111):
        plRegionBase.__init__(self,parent,name,type)
        self.vM70 = [] #hsMatrix34
    
    def read(self,stream):
        plRegionBase.read(self,stream)
        count = stream.Read32()
        for i in range(count):
            self.vM70[i] = hsMatrix34()
            self.vM70.read(stream)
    
    def write(self,stream):
        plRegionBase.write(self,stream)
        count = len(self.vM70)
        stream.Write32(count)
        for i in range(count):
            self.vM70.write(stream)


class plHardRegionComplex(plRegionBase):
    def __init__(self,parent,name="unnamed",type=0x0112):
        plRegionBase.__init__(self,parent,name,type)
        self.vHR70 = hsTArray([],self.getVersion())
    
    def read(self,stream):
        plRegionBase.read(self,stream)
        self.vHR70.read(self,stream)
    
    def write(self,stream):
        plRegionBase.write(self,stream)
        self.vHR70.write(stream)
    
    def changePageRaw(self,sid,did,stype,dtype):
        plRegionBase.changePageRaw(self,sid,did,stype,dtype)
        self.vHR70.changePageRaw(sid,did,stype,dtype)


class plVisRegion(plObjInterface):
    def __init__(self,parent,name="unnamed",type=0x0116):
        plObjInterface.__init__(self,parent,name,type)
        self.rB60 = UruObjectRef(self.getVersion())
        self.vM64 = UruObjectRef(self.getVersion())
    
    def read(self,stream):
        plObjInterface.read(self,stream)
        self.vM64.read(stream)
        self.rB60.read(stream)
    
    def write(self,stream):
        plObjInterface.write(self,stream)
        self.vM64.write(stream)
        self.rB60.write(stream)
    
    def dump(self):
        plObjInterface.dump(self)
        print "BEGIN plVisRegion " + self.Key.name
        print "VisMgr " + self.vM64.Key.name
        print "RegionBase " + self.rB60.Key.name
        print "END plVisRegion"
    
    def changePageRaw(self,sid,did,stype,dtype):
        plObjInterface.changePageRaw(self,sid,did,stype,dtype)
        self.rB60.changePageRaw(sid,did,stype,dtype)
        self.vM64.changePageRaw(sid,dad,stype,dtype)
