#
# $Id: alcxmlparser2.py 862 2007-11-05 23:07:02Z trylon $
#
#    Copyright (C) 2005-2006  Alcugs pyprp Project Team
#    See the file AUTHORS for more info about the team
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Please see the file COPYING for the full license.
#    Please see the file DISCLAIMER for more details, before doing nothing.
#

import HTMLParser


class alcpnode:
    def __init__(self,name,attrs):
        self.name=name
        self.attrs=attrs
        self.data=""


class alcXMLParser(HTMLParser.HTMLParser):
    def __init__(self):
        HTMLParser.HTMLParser.__init__(self)
        self.stack=[]
        self.current=None


    def handle_starttag(self, tag, attrs):
        self.start_element(tag,attrs)



    def start_element(self,name,attrs):
        #print "Start element:", name, attrs
        if self.current==None:
            self.current=self
        node=alcpnode(name,attrs)
        try:
            var=getattr(self.current,"x" + name)
            var.append(node)
        except (AttributeError, RuntimeError):
            setattr(self.current,"x" + name.lower(),[node,])
        self.current=node
        self.stack.append(node)


    def handle_endtag(self, tag):
        self.end_element(tag)


    def end_element(self,name):
        #print "End element", name
        if self.current!=None:
            self.stack.remove(self.current)
            if len(self.stack)>0:
                self.current=self.stack[len(self.stack)-1]
            else:
                self.current=None


    def handle_data(self, data):
        self.char_data(data)


    def handle_charref(self, name):
        value = int(name)
        character = ascii.unctrl(value)
        self.char_data(str(character))


    def handle_entityref(self, name):
        self.char_data(name)


    def char_data(self,data):
        #print "Character data:", repr(data)
        if self.current!=None:
            self.current.data = self.current.data + repr(data)


    def parse(self,input):
        self.feed(input)
        self.close()


##a=alcXMLParser()
##a.parse("""<?xml version="1.0"?>
##        <data>
##        <sceneobject>
##         <name>AgeSDLHook</name>
##         <modifier type="PythonFileMod">
##          <name>veryverySpecialPythonFileMod</name>
##          <script>script.py</script>
##         </modifier>
##        </sceneobject>
##
##        <sceneobject>
##         <name>AgeSDLHook</name>
##         <modifier type="PythonFileMod">
##          <name>veryverySpecialPythonFileMod</name>
##          <script>script.py</script>
##
##         </modifier>
##        </sceneobject>
##        </data>
##
##        """)

