#!BPY

""" Registration info for Blender menus:
Name: 'PRP GUI'
Blender: 242
Group: 'Wizards'
Tip: 'Everything you need for Uru in one place'
"""

#__author__ = "Branan Riley (PaladinOfKaos), with input from Aloys, Robert the Rebuilder, Nah'dneb, and others"
#__url__ = ("ALCUGS wiki page, http://alcugs.almlys.org/wiki/index.php/PRPGUI",
#"Latest Information, http://agebuilders.vofd.org/forum/index.php?showforum=52")
#__version__ = "0.1"

#__bpydoc__ = """\
#This wizard contains everything needed to use Blender as a map editor for Uru. The documentation will be written later.
#"""

import Blender
import prpgui_common
from prpgui_common import *
import prpgui_intro
import prpgui_properties
import prpgui_export

# Main handler. This handles the menu bar at the top. For everything else,
# it calls the button function for the current screen.
def main_handler(evt):
	global debug, verbose_debug, current_screen
	global MNBR_INT, MNBR_ADD, MNBR_PRP, MNBR_PGE, MNBR_EXP
	if verbose_debug:
		print "Entering main button handler.\n"
	if evt == MNBR_INT:
		current_screen = MNBR_INT
		if debug:
			print "Screen set to Introduction."
	elif evt == MNBR_ADD:
		current_screen = MNBR_ADD
		if debug:
			print "Screen set to Add."
	elif evt == MNBR_PRP:
		current_screen = MNBR_PRP
		if debug:
			print "Screen set to Properties."
	elif evt == MNBR_PGE:
		current_screen = MNBR_PGE
		if debug:
			print "Screen set to Page/Book management."
	elif evt == MNBR_EXP:
		current_screen = MNBR_EXP
		if debug:
			print "Screen set to Export."
	else:
		if current_screen == MNBR_INT:
			print "ERROR: Shouldn't be recieving non-menubar events in this screen!\
			terminating...\n"
			Blender.Draw.Exit()
			return
		elif current_screen == MNBR_ADD:
			print "Not implemented yet. Shouldn't be recieving non-menubar events.\
			Terminating...\n"
			Blender.Draw.Exit()
			return
		elif current_screen == MNBR_PRP:
			prpgui_properties.handler(evt)
		elif current_screen == MNBR_PGE:
			print "Not implemented yet. Shouldn't be recieving non-menubar events.\
			Terminating...\n"
			Blender.Draw.Exit()
			return
		elif current_screen == MNBR_EXP:
			prpgui_export.handler(evt)

	Blender.Draw.Redraw(1)
	
# This is just a quick function for any page that isn't implemented yet
def not_implemented():
	global verbose_debug
	if verbose_debug:
		print "Entering fallback for a non-implemented draw function."
	Blender.BGL.glRasterPos2i(20, 400)
	Blender.Draw.Text("This Page Hasn't been implemented yet.")
	Blender.BGL.glRasterPos2i(40, 380)
	Blender.Draw.Text("Coming Soon!")

# main draw function. This draw the menubar at the top, and then calls
# whatever draw function is appropriate for the current screen.
def main_draw():
	global debug, verbose_current_screen
	global MNBR_INT, MNBR_ADD, MNBR_PRP, MNBR_PGE, MNBR_EXP
	if verbose_debug:
		print "Entering main draw function.\n"
	Blender.BGL.glColor3f(0.0, 0.0, 0.0)
	if current_screen == MNBR_INT:
		Blender.Draw.Toggle("Intro", MNBR_INT, 20, 430, 41, 20, YES, "Introduction Page")
		Blender.Draw.Toggle("Add", MNBR_ADD, 66, 430, 36, 20, NO, "Add page")
		Blender.Draw.Toggle("Properties", MNBR_PRP, 107, 430, 76, 20, NO, "Properties Page")
		Blender.Draw.Toggle("Book", MNBR_PGE, 188, 430, 56, 20, NO, "Book Management Page")
		Blender.Draw.Toggle("Export", MNBR_EXP, 249, 430, 51, 20, NO, "Export PAge")
		prpgui_intro.draw()
	elif current_screen == MNBR_ADD:
		Blender.Draw.Toggle("Intro", MNBR_INT, 20, 430, 41, 20, NO, "Introduction Page")
		Blender.Draw.Toggle("Add", MNBR_ADD, 66, 430, 36, 20, YES, "Add Page")
		Blender.Draw.Toggle("Properties", MNBR_PRP, 107, 430, 76, 20, NO, "Properties Page")
		Blender.Draw.Toggle("Book", MNBR_PGE, 188, 430, 56, 20, NO, "Book Management Page")
		Blender.Draw.Toggle("Export", MNBR_EXP, 249, 430, 51, 20, NO, "Export Page")
		not_implemented()
	elif current_screen == MNBR_PRP:
		Blender.Draw.Toggle("Intro", MNBR_INT, 20, 430, 41, 20, NO, "Introduction Page")
		Blender.Draw.Toggle("Add", MNBR_ADD, 66, 430, 36, 20, NO, "Add Page")
		Blender.Draw.Toggle("Properties", MNBR_PRP, 107, 430, 76, 20, YES, "Properties Page")
		Blender.Draw.Toggle("Book", MNBR_PGE, 188, 430, 56, 20, NO, "Book Management Page")
		Blender.Draw.Toggle("Export", MNBR_EXP, 249, 430, 51, 20, NO, "Export Page")
		prpgui_properties.draw()
	elif current_screen == MNBR_PGE:
		Blender.Draw.Toggle("Intro", MNBR_INT, 20, 430, 41, 20, NO, "Introduction Page")
		Blender.Draw.Toggle("Add", MNBR_ADD, 66, 430, 36, 20, NO, "Add Page")
		Blender.Draw.Toggle("Properties", MNBR_PRP, 107, 430, 76, 20, NO, "Properties Page")
		Blender.Draw.Toggle("Book", MNBR_PGE, 188, 430, 56, 20, YES, "Book Management Page")
		Blender.Draw.Toggle("Export", MNBR_EXP, 249, 430, 51, 20, NO, "Export Page")
		not_implemented()
	elif current_screen == MNBR_EXP:
		Blender.Draw.Toggle("Intro", MNBR_INT, 20, 430, 41, 20, NO, "Introduction Page")
		Blender.Draw.Toggle("Add", MNBR_ADD, 66, 430, 36, 20, NO, "Add Page")
		Blender.Draw.Toggle("Properties", MNBR_PRP, 107, 430, 76, 20, NO, "Properties Page")
		Blender.Draw.Toggle("Book", MNBR_PGE, 188, 430, 56, 20, NO, "Book Management Page")
		Blender.Draw.Toggle("Export", MNBR_EXP, 249, 430, 51, 20, YES, "Export Page")
		prpgui_export.draw()
	else:
		print "Someone messed up with their coding. terminating...\n"
		Blender.Draw.Quit()

# This function handles input events. This includes object selection, assuming
# the event handler is running.
def event(evt, val):
	global curobj
	if evt == Blender.Draw.ESCKEY:
		Blender.Draw.Exit()
	if evt == Blender.Draw.RIGHTMOUSE:
		prpgui_properties.obj_setup()
		Blender.Draw.Redraw(0)


# Loading event handler for 3D windows, to check for right-clicks, which
# signals a possible object change.
script_loaded = YES
def setup_view3d():
	# This code has been adapted from the bbrush script
	global script_loaded, YES, NO
	name = 'prp_event.py'
	for t in Blender.Text.Get():
		if t.name.startswith(name):
			return
	datadir = Blender.Get('datadir')
	if not datadir.endswith(Blender.sys.sep):
		datadir += Blender.sys.sep
	path = datadir + name
	try:
		t = Blender.Text.Load(path)
	except:
		Blender.Draw.PupMenu("ERROR: Couldn't load event handler Script!")
		script_loaded = NO

#setup_view3d()
script_loaded = YES

if script_loaded:
#	Blender.Draw.PupMenu("Please make sure the event handler in |view->space handler scripts->event: pyprp_gui.py |is activated")
	prpgui_properties.obj_setup()
	Blender.Draw.Register(main_draw, event, main_handler)

